local _ADDON_VERSION = "1.5"
local _ADDON_NAME = Inspect.Addon.Current()
local buffConfig = {}
local debuffConfig = {}
local currentConfig = nil
local refresh = false
local BUFFS_PER_COL = 20
local buffFrameLock = false
local isSecure = false
local buff_last = 0
local buffFrameVisible = true
local icon_width = 24
local context = UI.CreateContext("PadaBuffs")
local buff_table = {}
local buff_display_padding = 4
local player_frame_startx = 15
local player_frame_starty = 15
local buff_bar_width = 350
local buff_frame_height = 34
local buff_bar_startx = 1030
local buff_bar_starty = 290
local playerId = nil
local INFINITE_DURATION_BUFF_DUR = 99999999
local pb_frames_created = 0
local frame_cache = {}
local raid_frame_cache = {}
local UI_FONT_SIZE = 18
local refreshMode = false
local pb_def_prog_color = { 0.96, 0.63, 0.22 }
local debug_mode = false
local _STACK_BUFFS_VERTICAL = 5
local _STACK_BUFFS_HORIZONTAL = 10

local _BAR_PROG_MODE_FIXED = 0
local _BAR_PROG_MODE_VARIABLE = 1
local barProgressMode = _BAR_PROG_MODE_VARIABLE

local _CANCEL_ON_MIDDLE = 0
local _CANCEL_ON_RIGHT = 1

local _FULL_BAR = 0
local _EMPTY_BAR = 1


local barProgressModeTime=15
local _IS_BLACKLIST = 0
local _IS_WHITELIST = 1
local _CURRENT_LIST = _IS_BLACKLIST

local _MAX_FIXED_PROG_DUR=120
local _MIN_FIXED_PROG_DUR=5


local updateSpeed=1
local updateSpeedSecPer=100
local backgroundAlpha=50
local progressAlpha=50
local barfontColor={1,1,1}
local barbackgroundColor={0,0,0}

local _DOWN_RIGHT_DIRECTION = 1
local _UP_LEFT_DIRECTION = -1
local MIN_PADDING=0
local MAX_PADDING=10
local MIN_BACKGROUNDALPHA=0
local MAX_BACKGROUNDALPHA=100
local MIN_UPDATESPEED=1
local MAX_UPDATESPEED=6
local currentList={}

local hideBuffNoDuration = false

local selfBuffsOnly = false
local buffsPerRowCol = 15
local stackBuffsDirection = _DOWN_RIGHT_DIRECTION
local stackBuffsMode = _STACK_BUFFS_VERTICAL
local showDebuffsSeperate = true

local enableBlacklist=true
local enableWhitelist=true
local enableDebugBuffs=false
local buff_blacklist = {}
local buff_whitelist = {}

local lastBlacklistBuff
local cn = 0

local test_b = {debuff=true,remaining=96.9375,duration=96.9375,caster="u030C800000D8BCC0",begin=t,icon="Data/\UI/\ability_icons/\layonhands2z.dds",
  name="Healing SPray",ability="a000000003A946E87"..tostring(t)}
  
  local configWinOpen=false

function sortBlacklist()

  table.sort(currentList, function(a, b)



   

    return a.n < b.n
  end)
  
end


function pbIsListed(nme,listing)

for k,v in pairs(listing) do


if v.n:upper()==nme:upper() then 

return true

 end
end
return false
end

function pbAddBlacklistBuff(nme,ig)

if table.getn(currentList)>=110 then
print("Blacklist exceeds max size")
return
end

--if ig==nil then nme=(nme..tostring(cn)) end
cn=cn+1
for k,v in pairs(currentList) do
if v.n:upper()==nme:upper() then 


return end
end

--local frame = RiftLibs:getCachedFrame("PadaBuffs", "blacklist", pbblframe)

local blf = {new=true,n=nme}
table.insert(currentList,blf)
reloadBuffs()
end


extra_options_win = UI.CreateFrame("RiftWindow", "PadaBuffs", context)
extra_options_win:SetTitle("PadaBuffs Extra Options")
extra_options_win:SetVisible(false)
extra_options_win:SetLayer(999999)


extra_options_win:SetWidth(800)
extra_options_win:SetHeight(400)
extra_options_win:SetPoint("CENTER", UIParent, "CENTER")


extra_options_win.progress_type_txt = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_txt:SetText("Progress as % of")
extra_options_win.progress_type_txt:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",25,60)
extra_options_win.progress_type_txt:SetFontSize(UI_FONT_SIZE)

extra_options_win.progress_type_dur_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_dur_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",195,65)

extra_options_win.progress_type_dur_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_dur_text:SetText("Buff Duration")
extra_options_win.progress_type_dur_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",215,60)
extra_options_win.progress_type_dur_text:SetFontSize(UI_FONT_SIZE)


extra_options_win.progress_type_fixed_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_fixed_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",340,65)


function extra_options_win.progress_type_dur_check.Event.CheckboxChange()

local checked = extra_options_win.progress_type_dur_check:GetChecked()
if checked then currentConfig.c_barProgressMode=_BAR_PROG_MODE_VARIABLE else currentConfig.c_barProgressMode=_BAR_PROG_MODE_FIXED end
extra_options_win.progress_type_fixed_check:SetChecked(not checked)
reloadBuffs()
  TickE(true)
end

function extra_options_win.progress_type_fixed_check.Event.CheckboxChange()

local checked = extra_options_win.progress_type_fixed_check:GetChecked()
if checked then currentConfig.c_barProgressMode=_BAR_PROG_MODE_FIXED else currentConfig.c_barProgressMode=_BAR_PROG_MODE_VARIABLE end
extra_options_win.progress_type_dur_check:SetChecked(not checked)
reloadBuffs()
  TickE(true)
end
extra_options_win.progress_type_fixed_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_fixed_text:SetText("Fixed Time (sec)")
extra_options_win.progress_type_fixed_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",360,60)
extra_options_win.progress_type_fixed_text:SetFontSize(UI_FONT_SIZE)

extra_options_win.progress_type_fixed_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_fixed_slider:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",520,70)
extra_options_win.progress_type_fixed_slider:SetWidth(150)
extra_options_win.progress_type_fixed_slider:SetRange(_MIN_FIXED_PROG_DUR,_MAX_FIXED_PROG_DUR)


extra_options_win.progress_type_fixed_textfield = UI.CreateFrame("RiftTextfield", "PadaBuffs", extra_options_win)
extra_options_win.progress_type_fixed_textfield:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",680,65)
extra_options_win.progress_type_fixed_textfield:SetText("15")


extra_options_win.cancel_method_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_text:SetText("Cancel Buffs On")
extra_options_win.cancel_method_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",25,90)
extra_options_win.cancel_method_text:SetFontSize(UI_FONT_SIZE)

extra_options_win.cancel_method_middle_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_middle_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",195,93)

extra_options_win.cancel_method_middle_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_middle_text:SetText("Middle Mouse")
extra_options_win.cancel_method_middle_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",215,90)
extra_options_win.cancel_method_middle_text:SetFontSize(UI_FONT_SIZE)


extra_options_win.cancel_method_right_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_right_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",340,93)

extra_options_win.cancel_method_right_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_right_text:SetText("Right Mouse")
extra_options_win.cancel_method_right_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",360,90)
extra_options_win.cancel_method_right_text:SetFontSize(UI_FONT_SIZE)


extra_options_win.cancel_method_require_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_require_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",475,93)

extra_options_win.cancel_method_require_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.cancel_method_require_text:SetText("Require Key Held Down")
extra_options_win.cancel_method_require_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",495,90)
extra_options_win.cancel_method_require_text:SetFontSize(UI_FONT_SIZE)


extra_options_win.no_duration_buffs_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.no_duration_buffs_text:SetText("Durationless Buffs")
extra_options_win.no_duration_buffs_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",25,120)
extra_options_win.no_duration_buffs_text:SetFontSize(UI_FONT_SIZE)

extra_options_win.no_duration_buffs_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.no_duration_buffs_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",195,125)

extra_options_win.no_duration_buffs_ctext = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.no_duration_buffs_ctext:SetText("Full Progress Bar")
extra_options_win.no_duration_buffs_ctext:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",215,120)
extra_options_win.no_duration_buffs_ctext:SetFontSize(UI_FONT_SIZE)


extra_options_win.no_duration_buffs_empty_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.no_duration_buffs_empty_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",360,125)

extra_options_win.no_duration_buffs_empty_ctext = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.no_duration_buffs_empty_ctext:SetText("Empty Progress Bar")
extra_options_win.no_duration_buffs_empty_ctext:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",380,120)
extra_options_win.no_duration_buffs_empty_ctext:SetFontSize(UI_FONT_SIZE)

--c_useGradient
extra_options_win.use_gradient_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.use_gradient_text:SetText("Gradient Bar")
extra_options_win.use_gradient_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",25,150)
extra_options_win.use_gradient_text:SetFontSize(UI_FONT_SIZE)

extra_options_win.use_gradient_text_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", extra_options_win)
extra_options_win.use_gradient_text_check:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",195,150)

extra_options_win.use_gradient_enabled_text = UI.CreateFrame("Text", "PadaBuffs", extra_options_win)
extra_options_win.use_gradient_enabled_text:SetText("Enabled")
extra_options_win.use_gradient_enabled_text:SetPoint("TOPLEFT", extra_options_win, "TOPLEFT",215,145)
extra_options_win.use_gradient_enabled_text:SetFontSize(UI_FONT_SIZE)
--c_nodurBuffProg=exis_b_nodurBuffProg or _FULL_BAR,
--c_useGradient=exis_b_useGradient or true,


function extra_options_win.use_gradient_text_check.Event:CheckboxChange()

currentConfig.c_useGradient=extra_options_win.use_gradient_text_check:GetChecked()
reloadBuffs()
  TickE(true)
end
function extra_options_win.no_duration_buffs_check.Event:CheckboxChange()

local checked = extra_options_win.no_duration_buffs_check:GetChecked()
if checked then currentConfig.c_nodurBuffProg=_FULL_BAR else currentConfig.c_nodurBuffProg=_EMPTY_BAR end
extra_options_win.no_duration_buffs_empty_check:SetChecked(not checked)
reloadBuffs()
  TickE(true)

end

function extra_options_win.no_duration_buffs_empty_check.Event:CheckboxChange()

local checked = extra_options_win.no_duration_buffs_empty_check:GetChecked()
if checked then currentConfig.c_nodurBuffProg=_EMPTY_BAR else currentConfig.c_nodurBuffProg=_FULL_BAR end
extra_options_win.no_duration_buffs_check:SetChecked(not checked)
reloadBuffs()
  TickE(true)

end

extra_options_win.close_button = UI.CreateFrame("RiftButton", "PadaBuffs", extra_options_win)
extra_options_win.close_button:SetText("Close")
extra_options_win.close_button:SetPoint("BOTTOMRIGHT", extra_options_win, "BOTTOMRIGHT",-20,-15)



function extra_options_win.cancel_method_middle_check.Event:CheckboxChange()

local checked = extra_options_win.cancel_method_middle_check:GetChecked()
if checked then currentConfig.c_cancelMode = _CANCEL_ON_MIDDLE else currentConfig.c_cancelMode = _CANCEL_ON_RIGHT end
extra_options_win.cancel_method_right_check:SetChecked(not checked)
reloadBuffs()
  TickE(true)
end



function extra_options_win.cancel_method_right_check.Event:CheckboxChange()

local checked = extra_options_win.cancel_method_right_check:GetChecked()
if checked then currentConfig.c_cancelMode = _CANCEL_ON_RIGHT else currentConfig.c_cancelMode = _CANCEL_ON_MIDDLE end
 extra_options_win.cancel_method_middle_check:SetChecked(not checked)
 reloadBuffs()
  TickE(true)
end

function extra_options_win.cancel_method_require_check.Event:CheckboxChange()

currentConfig.c_cancelRequireKey=extra_options_win.cancel_method_require_check:GetChecked()
end

--exis_b_cancelMode c_cancelRequireKey  _CANCEL_ON_RIGHT _CANCEL_ON_MIDDLE

--c_barProgressModeTime c_barProgressMode
function extra_options_win.progress_type_fixed_textfield.Event.TextfieldChange()

local num = tonumber(extra_options_win.progress_type_fixed_textfield:GetText())
if num and num >=_MIN_FIXED_PROG_DUR and num<=_MAX_FIXED_PROG_DUR then

 extra_options_win.progress_type_fixed_slider:SetPosition(num)
 currentConfig.c_barProgressModeTime=num
end
reloadBuffs()
  TickE(true)
end
function extra_options_win.progress_type_fixed_slider.Event.SliderChange()

currentConfig.c_barProgressModeTime=extra_options_win.progress_type_fixed_slider:GetPosition()
 extra_options_win.progress_type_fixed_textfield:SetText(tostring( currentConfig.c_barProgressModeTime))
reloadBuffs()
  TickE(true)
end
pb_blacklist_ui = UI.CreateFrame("RiftWindow", "PadaBuffs", context)

pb_blacklist_ui:SetVisible(false)
pb_blacklist_ui:SetLayer(999999)


pb_blacklist_ui:SetWidth(1300)
pb_blacklist_ui:SetHeight(700)
pb_blacklist_ui:SetPoint("CENTER", UIParent, "CENTER")
pb_blacklist_ui:SetTitle("PadaBuffs Buff / Debuff Blacklist")

pb_blacklist_ui.add_txt=UI.CreateFrame("Text", "PadaBuffs", pb_blacklist_ui)
 pb_blacklist_ui.add_txt:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT",20,0)
 pb_blacklist_ui.add_txt:SetText("Add to list")
 pb_blacklist_ui.add_txt:SetFontSize(18)
 
   pb_blacklist_ui.text_field=UI.CreateFrame("RiftTextfield", "Test", pb_blacklist_ui)
  pb_blacklist_ui.text_field:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT", 120, -15)
  pb_blacklist_ui.text_field:SetText("Enter Buff Name")
   pb_blacklist_ui.text_field:SetWidth(220)
   
     pb_blacklist_ui.text_add_button=UI.CreateFrame("RiftButton", "Test", pb_blacklist_ui)
  pb_blacklist_ui.text_add_button:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT", 360, -10)
  pb_blacklist_ui.text_add_button:SetText("Add Buff")
  
    pb_blacklist_ui.remove_sel=UI.CreateFrame("RiftButton", "Test", pb_blacklist_ui)
	 pb_blacklist_ui.remove_sel:SetEnabled(false)
  pb_blacklist_ui.remove_sel:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT", 500, -10)
  pb_blacklist_ui.remove_sel:SetText("Remove Selected")
  
  
  

  function pb_blacklist_ui.remove_sel.Event:LeftClick()
  
  
  pbbl(lastBlacklistBuff.n)
  lastBlacklistBuff.f:SetBackgroundColor(1, 1, 0,0.2)
  lastBlacklistBuff=nil
    pb_blacklist_ui.remove_sel:SetEnabled(false)
  end
  
    pb_blacklist_ui.enable_blacklist=UI.CreateFrame("RiftCheckbox", "Test", pb_blacklist_ui)
  pb_blacklist_ui.enable_blacklist:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT", 770, -19)
  
  
   pb_blacklist_ui.close_button=UI.CreateFrame("RiftButton", "Test", pb_blacklist_ui)
  pb_blacklist_ui.close_button:SetPoint("BOTTOMRIGHT", pb_blacklist_ui, "BOTTOMRIGHT", -10, -10)
  pb_blacklist_ui.close_button:SetText("Close")
  
     pb_blacklist_ui.update_button=UI.CreateFrame("RiftButton", "Test", pb_blacklist_ui)
  pb_blacklist_ui.update_button:SetPoint("BOTTOMRIGHT", pb_blacklist_ui, "BOTTOMRIGHT", -140, -10)
  pb_blacklist_ui.update_button:SetText("Update")
  
  
      pb_blacklist_ui.swap_lists_button=UI.CreateFrame("RiftButton", "Test", pb_blacklist_ui)
  pb_blacklist_ui.swap_lists_button:SetPoint("BOTTOMRIGHT", pb_blacklist_ui, "BOTTOMRIGHT", -270, -10)
  pb_blacklist_ui.swap_lists_button:SetText("To Whitelist")
 
 
  function pb_blacklist_ui.swap_lists_button.Event:LeftClick()
  
  if lastBlacklistBuff then
  lastBlacklistBuff.f:SetBackgroundColor(1, 1, 0,0.2)
  lastBlacklistBuff=nil
    pb_blacklist_ui.remove_sel:SetEnabled(false)
	
	end
	
   for k,v in pairs(currentList) do
   v.new=true

   RiftLibs:releaseCachedFrame(v.f)

end


if _CURRENT_LIST==_IS_WHITELIST then 
pb_blacklist_ui:SetTitle("PadaBuffs Buff / Debuff Blacklist")
 _CURRENT_LIST=_IS_BLACKLIST
 currentList=buff_blacklist
 --buff_blacklist  buff_whitelist _IS_BLACKLIST   _IS_WHITELIST
pb_blacklist_ui.swap_lists_button:SetText("To Whitelist")
 pb_blacklist_ui.enable_blacklist:SetChecked(enableWhitelist)
 
 else
 pb_blacklist_ui:SetTitle("PadaBuffs Buff / Debuff Whitelist")
 _CURRENT_LIST=_IS_WHITELIST
 currentList=buff_whitelist
 
  pb_blacklist_ui.swap_lists_button:SetText("To Blacklist")
  pb_blacklist_ui.enable_blacklist:SetChecked(enableBlacklist)
 end
 
 
 pbPositionBlacklist()
end
 
 
     function pb_blacklist_ui.close_button.Event:LeftClick()
	 
	
  pb_blacklist_ui:SetVisible(false)
  sortBlacklist()
  pbPositionBlacklist()
reloadBuffs()
TickE(true)
buff_frame_p:SetKeyFocus(false)
  end
  
    function pb_blacklist_ui.update_button.Event:LeftClick()
  sortBlacklist()
  pbPositionBlacklist()
reloadBuffs()
  end
  function pb_blacklist_ui.enable_blacklist.Event:CheckboxChange()
  --enableWhitelist
  if _CURRENT_LIST==_IS_BLACKLIST then 
   enableBlacklist=pb_blacklist_ui.enable_blacklist:GetChecked()
  else
   enableWhitelist=pb_blacklist_ui.enable_blacklist:GetChecked()
  end
 
  reloadBuffs()
  TickE(true)
  end
  pb_blacklist_ui.enable_blacklist_txt=UI.CreateFrame("Text", "PadaBuffs", pb_blacklist_ui)
 pb_blacklist_ui.enable_blacklist_txt:SetPoint("BOTTOMLEFT", pb_blacklist_ui, "BOTTOMLEFT",640,0)
 pb_blacklist_ui.enable_blacklist_txt:SetText("Enable Filtering")
 pb_blacklist_ui.enable_blacklist_txt:SetFontSize(18)
  
  
  function pb_blacklist_ui.text_add_button.Event:LeftClick()
  
  pbAddBlacklistBuff(pb_blacklist_ui.text_field:GetText())
  pbPositionBlacklist()
  TickE(true)
  end
local pb_bfbl_height = 25
local pb_bfbl_pad = 2
local pb bfbl_width = 250


function pbblframe()


local fr = UI.CreateFrame("Frame", "Test", pb_blacklist_ui)

fr:SetHeight(pb_bfbl_height)
fr:SetWidth(bfbl_width)
  fr:SetVisible(true)
  fr:SetBackgroundColor(1, 1, 0,0.2)
 
  fr:SetPoint("TOPLEFT", pb_blacklist_ui, "TOPLEFT", 0, 0)
  fr.text=UI.CreateFrame("RiftTextfield", "Test", fr)
  fr.text:SetPoint("TOPLEFT", fr, "TOPLEFT", 0, 0)
  fr.text:SetWidth(bfbl_width)
 -- fr.remove_button=UI.CreateFrame("RiftButton", "Test", fr)
 -- fr.remove_button:SetPoint("TOPRIGHT", fr, "TOPRIGHT", 0, -4)
  --fr.remove_button:SetText("Remove")
  

  
return fr

end

function pbbl(nme)

for k,v in pairs(currentList) do
if v.n:upper()==nme:upper() then 
table.remove(currentList,k)
RiftLibs:releaseCachedFrame(v.f)
 end
end

pbPositionBlacklist()
reloadBuffs()
  TickE(true)
end



function pbUpdateSel(sl)
pb_blacklist_ui.remove_sel:SetEnabled(true)
	if lastBlacklistBuff then
	lastBlacklistBuff.f:SetBackgroundColor(1, 1, 0,0.2)
	end
	sl.f:SetBackgroundColor(1, 0, 0,0.2)
	lastBlacklistBuff=sl
	
end
function pbPositionBlacklist()

sortBlacklist()

local xpos = 25
local ypos = 55
local ncount = 0
for k,v in pairs(currentList) do

	local kv=k
    if v.new then
	v.f =RiftLibs:getCachedFrame("PadaBuffs", "blacklist", pbblframe)
	function v.f.text.Event:TextfieldChange()
	
	v.n=v.f.text:GetText()
	
	end
	function v.f.text.Event:LeftClick() pbUpdateSel(v) end
	function v.f.Event:LeftClick() pbUpdateSel(v) end
	
	v.f.text:SetText(v.n)
	v.f:SetVisible(true)
	v.new=false
	end
	
	 v.f:SetPoint("TOPLEFT", pb_blacklist_ui, "TOPLEFT", xpos, ypos)
	ypos=ypos+pb_bfbl_height+pb_bfbl_pad
	ncount=ncount+1
	
	if ncount>21 then
	ncount=0
	xpos=xpos+bfbl_width+pb_bfbl_pad
	ypos = 55
	end
end

end


local dmg_config_rt = UI.CreateFrame("RiftWindow", "PadaBuffs", context)
dmg_config_rt:SetVisible(false)

dmg_config_rt:SetWidth(570)
dmg_config_rt:SetHeight(795)
dmg_config_rt:SetPoint("CENTER", UIParent, "CENTER")
dmg_config_rt:SetTitle("PadaBuffs Configuration")



function extra_options_win.close_button.Event:LeftClick()
extra_options_win:SetVisible(false)
dmg_config_rt:SetVisible(true)
buff_frame_p:SetKeyFocus(false)

end

local pd_font_size = 16
local show_name = true
local show_prog = true
local show_icons = true
-- RiftWindow

local MAX_BAR_WIDTH = 450
local MIN_BAR_WIDTH = 0
local MIN_FONT_SIZE = 12
local MAX_FONT_SIZE = 32
local MIN_BAR_HEIGHT = 16
local MAX_BAR_HEIGHT = 48

local pd_poison_color = { 0, 0.25, 0, 0.5 }
local pd_pdisease_color = { 1, 0.501, 0, 0.5 }
local pd_curse_color = { 0.501, 0, 1, 0.5 }
local pd_debuff_color = { 0.73, 0, 0.5 }
local pd_buff_color = { 0.776, 0.776, 0, 0.5 }


local dmg_config_win = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 0, 0)
dmg_config_win:SetWidth(650)
dmg_config_win:SetHeight(45)


--dmg_config_win:SetBackgroundColor(1,0,0)

dmg_config_win.bar_width_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_width_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 55)
dmg_config_win.bar_width_text:SetText("Buff bar width")
dmg_config_win.bar_width_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 65)
dmg_config_win.slider:SetWidth(260)
dmg_config_win.slider:SetHeight(35)
dmg_config_win.slider:SetRange(MIN_BAR_WIDTH, MAX_BAR_WIDTH)


dmg_config_win.slider_txt_val = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.slider_txt_val:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 460, 60)
dmg_config_win.slider_txt_val:SetWidth(55)
dmg_config_win.slider_txt_val:SetText(tostring(buff_bar_width))


function dmg_config_win.slider_txt_val.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.slider_txt_val:GetText())

  if num and num >= MIN_BAR_WIDTH and num <= MAX_BAR_WIDTH then
   currentConfig.c_bar_width = num

    dmg_config_win.slider:SetPosition(num)

    TickE(true)
  end
end


--90 
dmg_config_win.bar_display_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 140)
dmg_config_win.bar_display_text:SetText("What to show")
dmg_config_win.bar_display_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.bar_display_checkbox_icon = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_icon:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 183, 145)
dmg_config_win.bar_display_checkbox_icon:SetChecked(show_icons)


dmg_config_win.bar_display_checkbox_icon_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_icon_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 200, 140)
dmg_config_win.bar_display_checkbox_icon_text:SetText("Buff Icon")
dmg_config_win.bar_display_checkbox_icon_text:SetFontSize(UI_FONT_SIZE)



dmg_config_win.bar_display_checkbox_name = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_name:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 290, 145)
dmg_config_win.bar_display_checkbox_name:SetChecked(show_name)


dmg_config_win.bar_display_checkbox_name_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_name_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 310, 140)
dmg_config_win.bar_display_checkbox_name_text:SetText("Buff Name")
dmg_config_win.bar_display_checkbox_name_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.bar_display_checkbox_progress = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_progress:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 410, 145)
dmg_config_win.bar_display_checkbox_progress:SetChecked(show_prog)

dmg_config_win.bar_display_checkbox_progress_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_display_checkbox_progress_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 430, 140)
dmg_config_win.bar_display_checkbox_progress_text:SetText("Progress")
dmg_config_win.bar_display_checkbox_progress_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.text_size_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.text_size_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 90)
dmg_config_win.text_size_text:SetText("Font Size")
dmg_config_win.text_size_text:SetFontSize(UI_FONT_SIZE)


--140
dmg_config_win.text_size_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.text_size_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 112)
dmg_config_win.text_size_slider:SetWidth(260)
dmg_config_win.text_size_slider:SetHeight(35)
dmg_config_win.text_size_slider:SetRange(MIN_FONT_SIZE, MAX_FONT_SIZE)
dmg_config_win.text_size_slider:SetEnabled(true)



dmg_config_win.text_size_slider_val = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.text_size_slider_val:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 460, 107)
dmg_config_win.text_size_slider_val:SetWidth(55)
dmg_config_win.text_size_slider_val:SetText(tostring(pd_font_size))


function dmg_config_win.text_size_slider_val.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.text_size_slider_val:GetText())

  if num and num >= MIN_FONT_SIZE and num <= MAX_FONT_SIZE then
   currentConfig.c_font_size = num

    --Slider currently bugged this wont work
    dmg_config_win.text_size_slider:SetPosition(num)

    TickE(true)
  end
end







dmg_config_win.prog_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 180)
dmg_config_win.prog_color_text:SetText("Buff bar colour")
dmg_config_win.prog_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.prog_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 180)
dmg_config_win.prog_color_text:SetText("Red")
dmg_config_win.prog_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.prog_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 180)
dmg_config_win.prog_color_textfield_r:SetText(tostring(math.floor(pb_def_prog_color[1] * 255)))
dmg_config_win.prog_color_textfield_r:SetWidth(30)


dmg_config_win.prog_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 180)
dmg_config_win.prog_color_text:SetText("Green")
dmg_config_win.prog_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.prog_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 180)
dmg_config_win.prog_color_textfield_g:SetText(tostring(math.floor(pb_def_prog_color[2] * 255)))
dmg_config_win.prog_color_textfield_g:SetWidth(30)


dmg_config_win.prog_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 180)
dmg_config_win.prog_color_text:SetText("Blue")
dmg_config_win.prog_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.prog_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 180)
dmg_config_win.prog_color_textfield_b:SetText(tostring(math.floor(pb_def_prog_color[3] * 255)))
dmg_config_win.prog_color_textfield_b:SetWidth(30)





dmg_config_win.prog_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.prog_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 180)
dmg_config_win.prog_color_eg:SetHeight(20)
dmg_config_win.prog_color_eg:SetWidth(50)
dmg_config_win.prog_color_eg:SetBackgroundColor(pd_buff_color[1], pd_buff_color[2], pd_buff_color[3], 0.5)




function dmg_config_win.prog_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.prog_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.buff_c[1] = num / 255
    dmg_config_win.prog_color_eg:SetBackgroundColor(currentConfig.buff_c[1], currentConfig.buff_c[2], currentConfig.buff_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.prog_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.prog_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.buff_c[2] = num / 255
    dmg_config_win.prog_color_eg:SetBackgroundColor(currentConfig.buff_c[1], currentConfig.buff_c[2], currentConfig.buff_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.prog_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.prog_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.buff_c[3] = num / 255
    dmg_config_win.prog_color_eg:SetBackgroundColor(currentConfig.buff_c[1], currentConfig.buff_c[2], currentConfig.buff_c[3], 0.5)
    TickE(true)
  end
end





dmg_config_win.debuff_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 210)
dmg_config_win.debuff_color_textl:SetText("Debuff bar colour")
dmg_config_win.debuff_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.debuff_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 210)
dmg_config_win.debuff_color_text:SetText("Red")
dmg_config_win.debuff_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.debuff_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 210)
--dmg_config_win.debuff_color_textfield_r:SetText(tostring(math.floor(pd_debuff_color[1] * 255)))
dmg_config_win.debuff_color_textfield_r:SetWidth(30)

dmg_config_win.debuff_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 210)
dmg_config_win.debuff_color_text:SetText("Green")
dmg_config_win.debuff_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.debuff_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 210)
--dmg_config_win.debuff_color_textfield_g:SetText(tostring(math.floor(pd_debuff_color[2] * 255)))
dmg_config_win.debuff_color_textfield_g:SetWidth(30)


dmg_config_win.debuff_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 210)
dmg_config_win.debuff_color_text:SetText("Blue")
dmg_config_win.debuff_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.debuff_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 210)
--dmg_config_win.debuff_color_textfield_b:SetText(tostring(math.floor(pd_debuff_color[3] * 255)))
dmg_config_win.debuff_color_textfield_b:SetWidth(30)

dmg_config_win.debuff_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.debuff_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 212)
dmg_config_win.debuff_color_eg:SetHeight(20)
dmg_config_win.debuff_color_eg:SetWidth(50)
--dmg_config_win.debuff_color_eg:SetBackgroundColor(pd_debuff_color[1], pd_debuff_color[2], pd_debuff_color[3], 0.5)


function dmg_config_win.debuff_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.debuff_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then
    dmg_config_win.debuff_color_eg:SetBackgroundColor(currentConfig.debuff_c[1], currentConfig.debuff_c[2], currentConfig.debuff_c[3], 0.5)
    currentConfig.debuff_c[1] = num / 255
    TickE(true)
  end
end

function dmg_config_win.debuff_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.debuff_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then
    currentConfig.debuff_c[2] = num / 255
    dmg_config_win.debuff_color_eg:SetBackgroundColor(currentConfig.debuff_c[1], currentConfig.debuff_c[2], currentConfig.debuff_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.debuff_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.debuff_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then
    currentConfig.debuff_c[3] = num / 255
    dmg_config_win.debuff_color_eg:SetBackgroundColor(currentConfig.debuff_c[1], currentConfig.debuff_c[2], currentConfig.debuff_c[3], 0.5)
    TickE(true)
  end
end








dmg_config_win.curse_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 240)
dmg_config_win.curse_color_textl:SetText("Curse bar colour")
dmg_config_win.curse_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.curse_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 240)
dmg_config_win.curse_color_text:SetText("Red")
dmg_config_win.curse_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.curse_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 240)
--dmg_config_win.curse_color_textfield_r:SetText(tostring(math.floor(currentConfig.curse_c[1] * 255)))
dmg_config_win.curse_color_textfield_r:SetWidth(30)

dmg_config_win.curse_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 240)
dmg_config_win.curse_color_text:SetText("Green")
dmg_config_win.curse_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.curse_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 240)
--dmg_config_win.curse_color_textfield_g:SetText(tostring(math.floor(currentConfig.curse_c[2] * 255)))
dmg_config_win.curse_color_textfield_g:SetWidth(30)


dmg_config_win.curse_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 240)
dmg_config_win.curse_color_text:SetText("Blue")
dmg_config_win.curse_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.curse_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 240)
--dmg_config_win.curse_color_textfield_b:SetText(tostring(math.floor(currentConfig.curse_c[3] * 255)))
dmg_config_win.curse_color_textfield_b:SetWidth(30)

dmg_config_win.curse_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.curse_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 242)
dmg_config_win.curse_color_eg:SetHeight(20)
dmg_config_win.curse_color_eg:SetWidth(50)
--dmg_config_win.curse_color_eg:SetBackgroundColor(currentConfig.curse_c[1], currentConfig.curse_c[2], currentConfig.curse_c[3], 0.5)



function dmg_config_win.curse_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.curse_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.curse_c[1] = num / 255
    dmg_config_win.curse_color_eg:SetBackgroundColor(currentConfig.curse_c[1], currentConfig.curse_c[2], currentConfig.curse_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.curse_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.curse_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.curse_c[2] = num / 255
    dmg_config_win.curse_color_eg:SetBackgroundColor(currentConfig.curse_c[1], currentConfig.curse_c[2], currentConfig.curse_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.curse_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.curse_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.curse_c[3] = num / 255
    dmg_config_win.curse_color_eg:SetBackgroundColor(currentConfig.curse_c[1], currentConfig.curse_c[2], currentConfig.curse_c[3], 0.5)
    TickE(true)
  end
end


dmg_config_win.disease_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 270)
dmg_config_win.disease_color_textl:SetText("Disease bar colour")
dmg_config_win.disease_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.disease_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 270)
dmg_config_win.disease_color_text:SetText("Red")
dmg_config_win.disease_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.disease_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 270)
--dmg_config_win.disease_color_textfield_r:SetText(tostring(math.floor(pd_pdisease_color[1] * 255)))
dmg_config_win.disease_color_textfield_r:SetWidth(30)

dmg_config_win.disease_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 270)
dmg_config_win.disease_color_text:SetText("Green")
dmg_config_win.disease_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.disease_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 270)
--dmg_config_win.disease_color_textfield_g:SetText(tostring(math.floor(pd_pdisease_color[2] * 255)))
dmg_config_win.disease_color_textfield_g:SetWidth(30)


dmg_config_win.disease_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 270)
dmg_config_win.disease_color_text:SetText("Blue")
dmg_config_win.disease_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.disease_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 270)
--dmg_config_win.disease_color_textfield_b:SetText(tostring(math.floor(pd_pdisease_color[3] * 255)))
dmg_config_win.disease_color_textfield_b:SetWidth(30)

dmg_config_win.disease_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.disease_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 272)
dmg_config_win.disease_color_eg:SetHeight(20)
dmg_config_win.disease_color_eg:SetWidth(50)
--dmg_config_win.disease_color_eg:SetBackgroundColor(pd_pdisease_color[1], pd_pdisease_color[2], pd_pdisease_color[3], 0.5)

function dmg_config_win.disease_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.disease_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.disease_c[1] = num / 255
    dmg_config_win.disease_color_eg:SetBackgroundColor(currentConfig.disease_c[1], currentConfig.disease_c[2], currentConfig.disease_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.disease_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.disease_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.disease_c[2] = num / 255
    dmg_config_win.disease_color_eg:SetBackgroundColor(currentConfig.disease_c[1], currentConfig.disease_c[2], currentConfig.disease_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.disease_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.disease_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.disease_c[3] = num / 255
    dmg_config_win.disease_color_eg:SetBackgroundColor(currentConfig.disease_c[1], currentConfig.disease_c[2], currentConfig.disease_c[3], 0.5)
    TickE(true)
  end
end



dmg_config_win.poison_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 300)
dmg_config_win.poison_color_textl:SetText("Poison bar colour")
dmg_config_win.poison_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.poison_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 300)
dmg_config_win.poison_color_text:SetText("Red")
dmg_config_win.poison_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.poison_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 300)
--dmg_config_win.poison_color_textfield_r:SetText(tostring(math.floor(pd_poison_color[1] * 255)))
dmg_config_win.poison_color_textfield_r:SetWidth(30)

dmg_config_win.poison_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 300)
dmg_config_win.poison_color_text:SetText("Green")
dmg_config_win.poison_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.poison_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 300)
--dmg_config_win.poison_color_textfield_g:SetText(tostring(math.floor(pd_poison_color[2] * 255)))
dmg_config_win.poison_color_textfield_g:SetWidth(30)


dmg_config_win.poison_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 300)
dmg_config_win.poison_color_text:SetText("Blue")
dmg_config_win.poison_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.poison_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 300)
--dmg_config_win.poison_color_textfield_b:SetText(tostring(math.floor(currentConfig.poison_c[3] * 255)))
dmg_config_win.poison_color_textfield_b:SetWidth(30)

dmg_config_win.poison_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.poison_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 302)
dmg_config_win.poison_color_eg:SetHeight(20)
dmg_config_win.poison_color_eg:SetWidth(50)
--dmg_config_win.poison_color_eg:SetBackgroundColor(currentConfig.poison_c[1], currentConfig.poison_c[2], currentConfig.poison_c[3], 0.5)

function dmg_config_win.poison_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.poison_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.poison_c[1] = num / 255
    dmg_config_win.poison_color_eg:SetBackgroundColor(currentConfig.poison_c[1], currentConfig.poison_c[2], currentConfig.poison_c[3], 0.5)
    TickE(true)
  end
end

function dmg_config_win.poison_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.poison_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then
    dmg_config_win.poison_color_eg:SetBackgroundColor(currentConfig.poison_c[1], currentConfig.poison_c[2], currentConfig.poison_c[3], 0.5)
    currentConfig.poison_c[2] = num / 255
    TickE(true)
  end
end

function dmg_config_win.poison_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.poison_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then
    dmg_config_win.poison_color_eg:SetBackgroundColor(pd_poison_color[1], pd_poison_color[2], pd_poison_color[3], 0.5)
    currentConfig.poison_c[3] = num / 255
    TickE(true)
  end
end




dmg_config_win.bar_height_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_height_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 335)
dmg_config_win.bar_height_text:SetText("Buff bar height")
dmg_config_win.bar_height_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.bar_height_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_height_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 340)
dmg_config_win.bar_height_slider:SetWidth(260)
dmg_config_win.bar_height_slider:SetHeight(35)
dmg_config_win.bar_height_slider:SetRange(MIN_BAR_HEIGHT, MAX_BAR_HEIGHT)


dmg_config_win.bar_height_slider_val = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_height_slider_val:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 460, 332)
dmg_config_win.bar_height_slider_val:SetWidth(55)
dmg_config_win.bar_height_slider_val:SetText(tostring(buff_frame_height))




dmg_config_win.gen_txt = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.gen_txt:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 370)
dmg_config_win.gen_txt:SetText("General Options")
dmg_config_win.gen_txt:SetFontSize(UI_FONT_SIZE)


dmg_config_win.lock_bars_txt = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.lock_bars_txt:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 370)
dmg_config_win.lock_bars_txt:SetText("Lock")
dmg_config_win.lock_bars_txt:SetFontSize(UI_FONT_SIZE)

--buffFrameLock


dmg_config_win.visible_txt = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.visible_txt:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 370)
dmg_config_win.visible_txt:SetText("Visible")
dmg_config_win.visible_txt:SetFontSize(UI_FONT_SIZE)

dmg_config_win.visible_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.visible_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 325, 375)


dmg_config_win.lock_bars_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.lock_bars_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 240, 375)


dmg_config_win.selfbuffs_txt = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.selfbuffs_txt:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 345, 370)
dmg_config_win.selfbuffs_txt:SetText("Self Buffs Only")
dmg_config_win.selfbuffs_txt:SetFontSize(UI_FONT_SIZE)

dmg_config_win.selfbuffs_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.selfbuffs_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 470, 375)

function dmg_config_win.selfbuffs_check.Event:CheckboxChange()
  selfBuffsOnly = dmg_config_win.selfbuffs_check:GetChecked()
  reloadBuffs()
  TickE(true)
end

dmg_config_win.show_dps_seperate = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.show_dps_seperate:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 400)
dmg_config_win.show_dps_seperate:SetText("Separate Buffs/Debuffs")
dmg_config_win.show_dps_seperate:SetFontSize(UI_FONT_SIZE)
dmg_config_win.show_dps_seperate:SetWidth(250)


dmg_config_win.show_dps_seperate_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.show_dps_seperate_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 380, 405)


function dmg_config_win.show_dps_seperate_check.Event:CheckboxChange()
  showDebuffsSeperate = dmg_config_win.show_dps_seperate_check:GetChecked()
  reloadBuffs()
  TickE(true)
end


dmg_config_win.display_options = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.display_options:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 20, 425)
dmg_config_win.display_options:SetText("Display Options")
dmg_config_win.display_options:SetFontSize(UI_FONT_SIZE)
dmg_config_win.display_options:SetWidth(250)


dmg_config_win.hoziontal = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.hoziontal:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 430)
dmg_config_win.hoziontal:SetText("Horizonal")
dmg_config_win.hoziontal:SetFontSize(UI_FONT_SIZE)
dmg_config_win.hoziontal:SetWidth(250)



dmg_config_win.hoziontal_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.hoziontal_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 275, 435)


dmg_config_win.vertical = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.vertical:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 290, 430)
dmg_config_win.vertical:SetText("Vertical")
dmg_config_win.vertical:SetFontSize(UI_FONT_SIZE)
dmg_config_win.vertical:SetWidth(250)


dmg_config_win.vertical_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.vertical_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 355, 435)

--local stackBuffsDirection=_DOWN_RIGHT_DIRECTION
--local stackBuffsMode=_STACK_BUFFS_HORIZONTAL
function dmg_config_win.hoziontal_check.Event:CheckboxChange()
  local checked = dmg_config_win.hoziontal_check:GetChecked()
  dmg_config_win.vertical_check:SetChecked(not checked)
  if checked then currentConfig.c_stackBuffsMode = _STACK_BUFFS_HORIZONTAL else currentConfig.c_stackBuffsMode = _STACK_BUFFS_VERTICAL end

  reloadBuffs()
  TickE(true)
end

function dmg_config_win.vertical_check.Event:CheckboxChange()
  local checked = dmg_config_win.vertical_check:GetChecked()
  dmg_config_win.hoziontal_check:SetChecked(not checked)
  if checked then currentConfig.c_stackBuffsMode = _STACK_BUFFS_VERTICAL else currentConfig.c_stackBuffsMode = _STACK_BUFFS_HORIZONTAL end
 reloadBuffs()
  TickE(true)
end

dmg_config_win.max_per_rowcol = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.max_per_rowcol:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 368, 430)
dmg_config_win.max_per_rowcol:SetText("Buffs per row/col")
dmg_config_win.max_per_rowcol:SetFontSize(UI_FONT_SIZE)
dmg_config_win.vertical:SetWidth(250)


dmg_config_win.max_per_rowcol_field = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.max_per_rowcol_field:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 510, 435)
dmg_config_win.max_per_rowcol_field:SetText("15")


function dmg_config_win.max_per_rowcol_field.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.max_per_rowcol_field:GetText())

  if num and num > 1 then
    currentConfig.c_buffsPerRowCol = num
    reloadBuffs()
	 TickE(true)
  end
end


dmg_config_win.right_down = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.right_down:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 460)
dmg_config_win.right_down:SetText("Down")
dmg_config_win.right_down:SetFontSize(UI_FONT_SIZE)
dmg_config_win.right_down:SetWidth(250)


dmg_config_win.right_down_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.right_down_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 250, 465)


dmg_config_win.left_up = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.left_up:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 270, 460)
dmg_config_win.left_up:SetText("Up")
dmg_config_win.left_up:SetFontSize(UI_FONT_SIZE)
dmg_config_win.left_up:SetWidth(250)

dmg_config_win.left_up_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.left_up_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 310, 465)


dmg_config_win.left_dir = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.left_dir:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 330, 460)
dmg_config_win.left_dir:SetText("Left")
dmg_config_win.left_dir:SetFontSize(UI_FONT_SIZE)
dmg_config_win.left_dir:SetWidth(250)

dmg_config_win.left_dir_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.left_dir_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 370, 465)


dmg_config_win.right_dir = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.right_dir:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 390, 460)
dmg_config_win.right_dir:SetText("Right")
dmg_config_win.right_dir:SetFontSize(UI_FONT_SIZE)
dmg_config_win.right_dir:SetWidth(250)

dmg_config_win.right_dir_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.right_dir_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 440, 465)

local horizDirection = 1
local vertDirection = 1






function dmg_config_win.left_dir_check.Event:CheckboxChange()



  local checked = dmg_config_win.left_dir_check:GetChecked()
  if checked then currentConfig.c_horizDirection=-1  else currentConfig.c_horizDirection=1  end
dmg_config_win.right_dir_check:SetChecked(not dmg_config_win.left_dir_check:GetChecked())

reloadBuffs()
TickE(true)
end

function dmg_config_win.right_dir_check.Event:CheckboxChange()

local checked = dmg_config_win.right_dir_check:GetChecked()
  if checked then currentConfig.c_horizDirection=1  else currentConfig.c_horizDirection=-1  end

dmg_config_win.left_dir_check:SetChecked(not dmg_config_win.right_dir_check:GetChecked())


reloadBuffs()
TickE(true)
end


dmg_config_win.padding_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.padding_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 500)
dmg_config_win.padding_text:SetText("Padding")
dmg_config_win.padding_text:SetFontSize(UI_FONT_SIZE)
dmg_config_win.padding_text:SetWidth(250)

dmg_config_win.padding_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.padding_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 510)
dmg_config_win.padding_slider:SetWidth(260)

dmg_config_win.padding_slider:SetRange(MIN_PADDING, MAX_PADDING)


dmg_config_win.hide_no_dur_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.hide_no_dur_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 530)
dmg_config_win.hide_no_dur_text:SetText("Hide Buffs With No Duration")
dmg_config_win.hide_no_dur_text:SetFontSize(UI_FONT_SIZE)
dmg_config_win.hide_no_dur_text:SetWidth(250)



dmg_config_win.hide_no_dur_check = UI.CreateFrame("RiftCheckbox", "PadaBuffs", dmg_config_rt)
dmg_config_win.hide_no_dur_check:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 265, 534)

--hideBuffNoDuration
function dmg_config_win.hide_no_dur_check.Event:CheckboxChange()
hideBuffNoDuration=dmg_config_win.hide_no_dur_check:GetChecked()
reloadBuffs()
TickE(true)
end

dmg_config_win.padding_amount_text = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.padding_amount_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 480, 505)
dmg_config_win.padding_amount_text:SetText("15")


dmg_config_win.switch_to_debuffs = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.switch_to_debuffs:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 715)
dmg_config_win.switch_to_debuffs:SetText("Debuff Settings")

dmg_config_win.reset_position = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.reset_position:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 745)
dmg_config_win.reset_position:SetText("Reset Bar Pos")

dmg_config_win.enable_testbuffs = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.enable_testbuffs:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 155, 745)
dmg_config_win.enable_testbuffs:SetText("Test Buffs On")

dmg_config_win.more_options = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.more_options:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 285, 745)
dmg_config_win.more_options:SetText("More Options")



function dmg_config_win.more_options.Event:LeftClick()


  dmg_config_rt:SetVisible(false)
extra_options_win:SetVisible(true)


end
function dmg_config_win.reset_position.Event:LeftClick()

	
	 debuff_frame_p:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 25, 300)
	  buff_frame_p:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 500, 400)
	  
	  
end

function dmg_config_win.enable_testbuffs.Event:LeftClick()

if enableDebugBuffs then
enableDebugBuffs=false

dmg_config_win.enable_testbuffs:SetText("Test Buffs On")
else
addDebugBuffs()
dmg_config_win.enable_testbuffs:SetText("Test Buffs Off")
enableDebugBuffs=true
end
reloadBuffs()
TickE()
end

dmg_config_win.switch_to_buffs = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.switch_to_buffs:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 155, 715)
dmg_config_win.switch_to_buffs:SetText("Buff Settings")


dmg_config_win.close_button = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.close_button:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 420, 715)
dmg_config_win.close_button:SetText("Close")

dmg_config_win.blacklist_button = UI.CreateFrame("RiftButton", "PadaBuffs", dmg_config_rt)
dmg_config_win.blacklist_button:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 285, 715)
dmg_config_win.blacklist_button:SetText("Black/White Lists")



--Font colour

dmg_config_win.font_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 560)
dmg_config_win.font_color_textl:SetText("Font Colour")
dmg_config_win.font_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.font_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 560)
dmg_config_win.font_color_text:SetText("Red")
dmg_config_win.font_color_text:SetFontSize(UI_FONT_SIZE)



dmg_config_win.font_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 565)
dmg_config_win.font_color_textfield_r:SetText("12")
dmg_config_win.font_color_textfield_r:SetWidth(30)

dmg_config_win.font_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 560)
dmg_config_win.font_color_text:SetText("Green")
dmg_config_win.font_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.font_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 565)
dmg_config_win.font_color_textfield_g:SetText("12")
dmg_config_win.font_color_textfield_g:SetWidth(30)


dmg_config_win.font_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 560)
dmg_config_win.font_color_text:SetText("Blue")
dmg_config_win.font_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.font_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 565)
dmg_config_win.font_color_textfield_b:SetText("12")
dmg_config_win.font_color_textfield_b:SetWidth(30)

--c_barbackgroundColor c_barfontColor
function dmg_config_win.font_color_textfield_r.Event:TextfieldChange()

  local num = tonumber(dmg_config_win.font_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barfontColor[1] = num / 255

   dmg_config_win.font_color_eg:SetBackgroundColor(currentConfig.c_barfontColor[1], currentConfig.c_barfontColor[2], currentConfig.c_barfontColor[3])
    TickE(true)
  end
end

function dmg_config_win.font_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.font_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barfontColor[2] = num / 255
    dmg_config_win.font_color_eg:SetBackgroundColor(currentConfig.c_barfontColor[1], currentConfig.c_barfontColor[2], currentConfig.c_barfontColor[3])
    TickE(true)
  end
end

function dmg_config_win.font_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.font_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barfontColor[3] = num / 255
    dmg_config_win.font_color_eg:SetBackgroundColor(currentConfig.c_barfontColor[1], currentConfig.c_barfontColor[2], currentConfig.c_barfontColor[3])
    TickE(true)
  end
end

dmg_config_win.font_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.font_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 560)
dmg_config_win.font_color_eg:SetHeight(20)
dmg_config_win.font_color_eg:SetBackgroundColor(1,0,0,0.5)
dmg_config_win.font_color_eg:SetWidth(50)

--end font colour

--background colour


dmg_config_win.bar_color_textl = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_textl:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 590)
dmg_config_win.bar_color_textl:SetText("Bar Background")
dmg_config_win.bar_color_textl:SetFontSize(UI_FONT_SIZE)

dmg_config_win.bar_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 190, 590)
dmg_config_win.bar_color_text:SetText("Red")
dmg_config_win.bar_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.bar_color_textfield_r = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_textfield_r:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 230, 595)
dmg_config_win.bar_color_textfield_r:SetText("12")
dmg_config_win.bar_color_textfield_r:SetWidth(30)

dmg_config_win.bar_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 260, 590)
dmg_config_win.bar_color_text:SetText("Green")
dmg_config_win.bar_color_text:SetFontSize(UI_FONT_SIZE)


dmg_config_win.bar_color_textfield_g = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_textfield_g:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 320, 595)
dmg_config_win.bar_color_textfield_g:SetText("12")
dmg_config_win.bar_color_textfield_g:SetWidth(30)


dmg_config_win.bar_color_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 350, 590)
dmg_config_win.bar_color_text:SetText("Blue")
dmg_config_win.bar_color_text:SetFontSize(UI_FONT_SIZE)

dmg_config_win.bar_color_textfield_b = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_textfield_b:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 400, 595)
dmg_config_win.bar_color_textfield_b:SetText("12")
dmg_config_win.bar_color_textfield_b:SetWidth(30)

dmg_config_win.bar_color_eg = UI.CreateFrame("Frame", "PadaBuffs", dmg_config_rt)
dmg_config_win.bar_color_eg:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 450, 590)
dmg_config_win.bar_color_eg:SetHeight(20)
dmg_config_win.bar_color_eg:SetBackgroundColor(1,0,0,0.5)
dmg_config_win.bar_color_eg:SetWidth(50)



--c_barbackgroundColor c_barfontColor
function dmg_config_win.bar_color_textfield_r.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.bar_color_textfield_r:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barbackgroundColor[1] = num / 255
    dmg_config_win.bar_color_eg:SetBackgroundColor(currentConfig.c_barbackgroundColor[1], currentConfig.c_barbackgroundColor[2], currentConfig.c_barbackgroundColor[3])
    TickE(true)
  end
end

function dmg_config_win.bar_color_textfield_g.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.bar_color_textfield_g:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barbackgroundColor[2] = num / 255
    dmg_config_win.bar_color_eg:SetBackgroundColor(currentConfig.c_barbackgroundColor[1], currentConfig.c_barbackgroundColor[2], currentConfig.c_barbackgroundColor[3])
    TickE(true)
  end
end

function dmg_config_win.bar_color_textfield_b.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.bar_color_textfield_b:GetText())
  if num and num > -1 and num <= 255 then

    currentConfig.c_barbackgroundColor[3] = num / 255
    dmg_config_win.bar_color_eg:SetBackgroundColor(currentConfig.c_barbackgroundColor[1], currentConfig.c_barbackgroundColor[2], currentConfig.c_barbackgroundColor[3])
    TickE(true)
  end
end



--end background colour

dmg_config_win.background_alpha_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.background_alpha_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 620)
dmg_config_win.background_alpha_text:SetText("Background alpha")
dmg_config_win.background_alpha_text:SetFontSize(UI_FONT_SIZE)
dmg_config_win.background_alpha_text:SetWidth(250)

-- 

dmg_config_win.background_alpha_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.background_alpha_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 195, 625)
dmg_config_win.background_alpha_slider:SetWidth(260)
dmg_config_win.background_alpha_slider:SetRange(MIN_BACKGROUNDALPHA, MAX_BACKGROUNDALPHA)

dmg_config_win.background_alpha_textfield = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.background_alpha_textfield:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 480, 620)
dmg_config_win.background_alpha_textfield:SetText("12")
dmg_config_win.background_alpha_textfield:SetWidth(30)

function dmg_config_win.background_alpha_textfield.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.background_alpha_textfield:GetText())
  if num and num > -1 and num <= 100 then

    currentConfig.c_backgroundAlpha = num
    dmg_config_win.background_alpha_slider:SetPosition(num)
    TickE(true)
  end
end




dmg_config_win.progress_alpha_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.progress_alpha_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 650)
dmg_config_win.progress_alpha_text:SetText("Progress alpha")
dmg_config_win.progress_alpha_text:SetFontSize(UI_FONT_SIZE)
dmg_config_win.progress_alpha_text:SetWidth(250)

-- progress_alpha_text

dmg_config_win.progress_alpha_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.progress_alpha_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 195, 655)
dmg_config_win.progress_alpha_slider:SetWidth(260)
dmg_config_win.progress_alpha_slider:SetRange(MIN_BACKGROUNDALPHA, MAX_BACKGROUNDALPHA)

dmg_config_win.progress_alpha_textfield = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.progress_alpha_textfield:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 480, 650)
dmg_config_win.progress_alpha_textfield:SetText("12")
dmg_config_win.progress_alpha_textfield:SetWidth(30)

function dmg_config_win.progress_alpha_textfield.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.progress_alpha_textfield:GetText())
  if num and num > -1 and num <= 100 then

    currentConfig.c_progressAlpha = num
    dmg_config_win.progress_alpha_slider:SetPosition(num)
    TickE(true)
  end
end

function dmg_config_win.progress_alpha_slider.Event.SliderChange()
currentConfig.c_progressAlpha=dmg_config_win.progress_alpha_slider:GetPosition()
dmg_config_win.progress_alpha_textfield:SetText(tostring(currentConfig.c_progressAlpha))

TickE(true)
end




dmg_config_win.update_speed_text = UI.CreateFrame("Text", "PadaBuffs", dmg_config_rt)
dmg_config_win.update_speed_text:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 25, 680)
dmg_config_win.update_speed_text:SetText("Update Speed")
dmg_config_win.update_speed_text:SetFontSize(UI_FONT_SIZE)
dmg_config_win.update_speed_text:SetWidth(250)





dmg_config_win.update_speed_slider = UI.CreateFrame("RiftSlider", "PadaBuffs", dmg_config_rt)
dmg_config_win.update_speed_slider:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 195, 685)
dmg_config_win.update_speed_slider:SetWidth(260)
dmg_config_win.update_speed_slider:SetRange(MIN_UPDATESPEED, MAX_UPDATESPEED)


--local barfontColor={1,1,1}







dmg_config_win.update_speed_textfield = UI.CreateFrame("RiftTextfield", "PadaBuffs", dmg_config_rt)
dmg_config_win.update_speed_textfield:SetPoint("TOPLEFT", dmg_config_rt, "TOPLEFT", 480, 680)
dmg_config_win.update_speed_textfield:SetText("12")
dmg_config_win.update_speed_textfield:SetWidth(30)

function dmg_config_win.progress_alpha_textfield.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.progress_alpha_textfield:GetText())
  if num and num >= 1 and num <= MAX_UPDATESPEED then

   -- updateSpeed = num
    --dmg_config_win.update_speed_slider:SetPosition(num)
    --TickE(true)
  end
end

function dmg_config_win.background_alpha_slider.Event.SliderChange()
currentConfig.c_backgroundAlpha=dmg_config_win.background_alpha_slider:GetPosition()
dmg_config_win.background_alpha_textfield:SetText(tostring(currentConfig.c_backgroundAlpha))

TickE(true)
end
function dmg_config_win.update_speed_slider.Event.SliderChange()
updateSpeed=dmg_config_win.update_speed_slider:GetPosition()
updateSpeedSecPer=1/updateSpeed
dmg_config_win.update_speed_textfield:SetText(tostring(updateSpeed))

TickE(true)
end

function dmg_config_win.switch_to_buffs.Event:LeftClick()
currentConfig=buffConfig
buff_frame_p:SetKeyFocus(false)
dmg_config_rt:SetTitle("PadaBuffs [Buff] Configuration")
pbUpdateConfig(buffConfig)
reloadBuffs()
end

function dmg_config_win.switch_to_debuffs.Event:LeftClick()
currentConfig=debuffConfig
buff_frame_p:SetKeyFocus(false)
dmg_config_rt:SetTitle("PadaBuffs [Debuff] Configuration")
pbUpdateConfig(debuffConfig)
reloadBuffs()
end

function dmg_config_win.blacklist_button.Event:LeftClick()
buff_frame_p:SetKeyFocus(false)
pb_blacklist_ui:SetVisible(true)
end

function dmg_config_win.padding_slider.Event.SliderChange()



  currentConfig.c_padding = dmg_config_win.padding_slider:GetPosition()

dmg_config_win.padding_amount_text:SetText(tostring(dmg_config_win.padding_slider:GetPosition()))

  TickE(true)
end

function dmg_config_win.padding_amount_text.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.padding_amount_text:GetText())

  if num and num >= MIN_PADDING and num<=MAX_PADDING then
  dmg_config_win.padding_slider:SetPosition(num)
    currentConfig.c_padding = num
    --reloadBuffs()
  end
end


--local stackBuffsDirection=_DOWN_RIGHT_DIRECTION
--local stackBuffsMode=_STACK_BUFFS_HORIZONTAL
function dmg_config_win.right_down_check.Event:CheckboxChange()
  local checked = dmg_config_win.right_down_check:GetChecked()
  
 
  dmg_config_win.left_up_check:SetChecked(not checked)
  if checked then currentConfig.c_vertDirection=1  else currentConfig.c_vertDirection=-1  end

  reloadBuffs()
  
  TickE(true)
end

function dmg_config_win.left_up_check.Event:CheckboxChange()


  local checked = dmg_config_win.left_up_check:GetChecked()
  
  dmg_config_win.right_down_check:SetChecked(not checked)
   if checked then currentConfig.c_vertDirection=-1  else currentConfig.c_vertDirection=1  end
  reloadBuffs()
  
  TickE(true)
  
end






function dmg_config_win.selfbuffs_check.Event:CheckboxChange()
  selfBuffsOnly = (dmg_config_win.selfbuffs_check:GetChecked())
 reloadBuffs()
  TickE(true)
end

function dmg_config_win.lock_bars_check.Event:CheckboxChange()
  buffFrameLock = (dmg_config_win.lock_bars_check:GetChecked())
end

function dmg_config_win.visible_check.Event:CheckboxChange()
  currentConfig.c_buffFrameVisible = dmg_config_win.visible_check:GetChecked()
  pbUpdateConfig(currentConfig)
end


function dmg_config_win.close_button.Event:LeftClick()
configWinOpen=false
enableDebugBuffs=false
dmg_config_win.enable_testbuffs:SetText("Test Buffs On")
  dmg_config_rt:SetVisible(false)
  buff_frame_drag:SetVisible(false)
  debuff_frame_drag:SetVisible(false)
  buff_frame_p:SetKeyFocus(false)
  reloadBuffs()
  TickE(true)
end

function dmg_config_win.bar_height_slider_val.Event:TextfieldChange()
  local num = tonumber(dmg_config_win.bar_height_slider_val:GetText())
  if num and num >= MIN_BAR_HEIGHT and num <= MAX_BAR_HEIGHT then
    currentConfig.c_bar_height = num
    --Slider currently bugged this wont work
    dmg_config_win.bar_height_slider:SetPosition(num)




    TickE(true)
  end
end


function dmg_config_win.bar_height_slider.Event.SliderChange()



  currentConfig.c_bar_height = dmg_config_win.bar_height_slider:GetPosition()

  if currentConfig==buffConfig then
  buff_frame_drag:SetHeight(currentConfig.c_bar_height)
  else
  debuff_frame_drag:SetHeight(currentConfig.c_bar_height)
  end

  

  

  --icon_width = currentConfig.c_bar_height
  dmg_config_win.bar_height_slider_val:SetText(tostring(dmg_config_win.bar_height_slider:GetPosition()))

  TickE(true)
end






function dmg_config_win.text_size_slider.Event.SliderChange()

  dmg_config_win.text_size_slider_val:SetText(tostring(dmg_config_win.text_size_slider:GetPosition()))

  currentConfig.c_font_size = dmg_config_win.text_size_slider:GetPosition()
  TickE(true)
end



function dmg_config_win.bar_display_checkbox_icon.Event:CheckboxChange()

  currentConfig.c_show_icons = dmg_config_win.bar_display_checkbox_icon:GetChecked()
  reloadBuffs()
  TickE(true)
end

function dmg_config_win.bar_display_checkbox_progress.Event:CheckboxChange()
  currentConfig.c_show_prog = dmg_config_win.bar_display_checkbox_progress:GetChecked()
  reloadBuffs()
  TickE(true)
end

function dmg_config_win.bar_display_checkbox_name.Event:CheckboxChange()
  currentConfig.c_show_name = dmg_config_win.bar_display_checkbox_name:GetChecked()

  reloadBuffs()
  TickE(true)
end





dmg_config_win.slider:SetEnabled(true)
--
local pdl = 0
local pd_slider_grab = false
function dmg_config_win.slider.Event.SliderGrab()
  pd_slider_grab = true
end

function dmg_config_win.slider.Event.SliderRelease()
  pd_slider_grab = false
end



function dmg_config_win.slider.Event.SliderChange()

  local wdt = dmg_config_win.slider:GetPosition()
  local t = Inspect.Time.Real()
  dmg_config_win.slider_txt_val:SetText(tostring(wdt))

  buff_frame_drag:SetWidth(currentConfig.c_bar_width + currentConfig.c_bar_height)

  debuff_frame_drag:SetWidth(currentConfig.c_bar_width + currentConfig.c_bar_height)

  currentConfig.c_bar_width = dmg_config_win.slider:GetPosition()
  pdl = t
  TickE(true)
end

--
RiftLibs:enableDrag(dmg_config_win)


local function sortBuffs()


  local t = Inspect.Time.Real()
  table.sort(buff_table, function(a, b)



    local remA = a.duration - (a.remaining - (a.complete - t))
    local remB = b.duration - (b.remaining - (b.complete - t))


    return remB < remA
  end)
end

local function padNum(num)

  if (num < 10) then return "0" .. num else return num end
end

local function setBuffColor(frame, buff_details)



  if (buff_details.poison) then
    frame:SetBackgroundColor(buff_details.config.poison_c[1], buff_details.config.poison_c[2], buff_details.config.poison_c[3], buff_details.config.c_progressAlpha/100)
    return
  end

  if (buff_details.disease) then
    frame:SetBackgroundColor(buff_details.config.disease_c[1], buff_details.config.disease_c[2], buff_details.config.disease_c[3], buff_details.config.c_progressAlpha/100)
    return
  end

  if (buff_details.curse) then
    frame:SetBackgroundColor(buff_details.config.curse_c[1], buff_details.config.curse_c[2], buff_details.config.curse_c[3], buff_details.config.c_progressAlpha/100)
    return
  end


  if (buff_details.debuff) then
  
    frame:SetBackgroundColor(buff_details.config.debuff_c[1], buff_details.config.debuff_c[2], buff_details.config.debuff_c[3], buff_details.config.c_progressAlpha/100)
    return
  end
 
  frame:SetBackgroundColor(buff_details.config.buff_c[1], buff_details.config.buff_c[2], buff_details.config.buff_c[3], buff_details.config.c_progressAlpha/100)
end





lastRecheckBuffs = 0

local function padabuffs_recheckBuffs()
  -- playerId


  local sBuff = Inspect.Buff.List("player")
  if not sBuff then return end

  for k2, v2 in pairs(buff_table) do
    local found = false

    for k, v in pairs(sBuff) do
      if v2.key == k then
        found = true
        break
      end
    end

    if found == false then


      releaseFrame(v2.frame)
      table.remove(buff_table, k2)
    end
  end
end

--[[
  local cpc = UI.CreateFrame("Text", "Test", context)
 

  cpc:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 400, 300)
  cpc:SetWidth(100)
 --]]
  


local lastUpdateDisplay=0
local lgcheck=0
function pbUpdateValues(forceUpdate)

  local t = Inspect.Time.Real()
  

  
   if t - lastRecheckBuffs > 5 and not enableDebugBuffs then
    padabuffs_recheckBuffs()
	--TickE(true,true)
    lastRecheckBuffs = t
  end
  
if t-lastUpdateDisplay>=updateSpeedSecPer or forceUpdate then
lastUpdateDisplay=t
else
return
end

for k, v in pairs(buff_table) do

 local rc = ""
      local stack_val = ""
      local perc = 1

  local comp = v.complete
        local dur = v.remaining

        local rem = v.duration - (v.remaining - (comp - t))

 local wdd = 0
     
	  
	  
        if rem > 0 then


		 
		 if v.config.c_barProgressMode==_BAR_PROG_MODE_FIXED then
		 
		 local rrm=v.duration-(v.remaining - (comp - t))
		 local vll=(rrm/v.config.c_barProgressModeTime)
	
	
		 wdd=math.min(v.config.c_bar_width*vll,v.config.c_bar_width)
			else
			
			    perc = ((v.remaining - (comp - t))) / v.duration
				wdd=v.config.c_bar_width - (v.config.c_bar_width * (perc))
			end

          local fm = math.fmod(rem * 100, 100) --(math.floor(rem*100)/100)
          rc = math.floor(rem)
          if rc >= 60 then

			thrs = math.floor(rc / 3600)
            tmin = math.floor(rc / 60 )%60
            tsec = ':'..padNum(math.floor(rc % 60))
			if thrs<1 then thrs = "" else 
			thrs = thrs..":" 
			tsec = "" 
			end
            rc = thrs..padNum(tmin) .. tsec
          else
            rc = '00:' .. padNum(rc)
          end

          if (v.stack) then
            stack_val = " (" .. v.stack .. ")"
          end
        end


		 if v.duration == INFINITE_DURATION_BUFF_DUR then
        rc = ""
        wdd = v.config.c_bar_width
		if v.config.c_nodurBuffProg==_EMPTY_BAR then
		wdd = 0
		end
      end
		
 if v.config.c_show_name then
        v.frame.txt:SetText(v.name .. stack_val .. ' ' .. rc)

      else
        v.frame.txt:SetText(stack_val .. ' ' .. rc)
      end
	  
	        local xoff = 0
        if v.config.c_show_icons then xoff = v.config.c_bar_height end


        v.frame.txt:ResizeToText() -- To be replaced with ClearSize() in 1.6
        v.frame.txt:SetWidth(v.config.c_bar_width)
        v.frame.txt:SetPoint("LEFTCENTER", v.frame, "LEFTCENTER", xoff, 0)
        v.frame:SetVisible(v.config.c_buffFrameVisible)

v.frame.prog:SetWidth(wdd)

end
     


--[[
   
       local cpu_usage = Inspect.Addon.Cpu()
     
       local addon_usage = cpu_usage[Inspect.Addon.Current()]

if addon_usage then

	   local tk = 0
   
       for v, k in pairs(addon_usage) do

			  tk=tk+k
            
       end

cpc:SetText(string.format("%08f%%", (tk*100)))
end
--]]



end

function addDebugBuffs()
 local t = Inspect.Time.Frame()

 
 local tn = {"Poison","Curse","Disease","Debuff"}
  local vl=0
 for variable = 0, 5, 1 do
 local typs = {false,false,false,false,false}
 vl=vl+1
 vl=math.mod(vl,4)
 
 typs[vl+1]=true

	 local test_b = {debuff=true,poison=typs[1],curse=typs[2],disease=typs[3],remaining=variable*60,duration=variable*60,caster="u030C800000D8BCC0",begin=t,icon="Data/\UI/\ability_icons/\layonhands2z.dds",
  name="Testing "..tn[vl+1],ability="gdfgdfgfd"..tostring(variable)}
	
	pdmg_addBuff(test_b, "a000000003A946E87"..tostring(variable), false, true)
	
end


 for variable = 0, 5, 1 do
 local typs = {false,false,false,false,false}
 local vl=math.floor(math.random()*4)+1
 typs[vl]=true
 
	 local test_b = {remaining=variable*60,duration=variable*60,caster="u030C800000D8BCC0",begin=t,icon="Data/\UI/\ability_icons/\layonhands2z.dds",
  name="Testing Buff ",ability="gdfgdfgfd"..tostring(variable)}
	
	pdmg_addBuff(test_b, "fff"..tostring(variable), false, true)
	
end
 
 TickE(true)
end
function TickE(time,avoidInfin)

   if currentConfig==nil then return end


   
  local t = Inspect.Time.Real()


 

  if (time or (t - buff_last > 1) or (pd_slider_grab)) then

  


    buff_last = t


    local topf, leftf = buff_frame_p:GetBounds()

    local incr = 50
    local xpos = 0 --buff_bar_startx
    local ypos = 0 --buff_bar_starty
    local ncount = 0

    buff_frame_p.xpos = 0
    buff_frame_p.ypos = 0
    buff_frame_p.ncount = 0

    debuff_frame_p.xpos = 0
    debuff_frame_p.ypos = 0
    debuff_frame_p.ncount = 0

if not avoidInfin then pbUpdateValues(t) end

    for k, v in pairs(buff_table) do

      if v.buffFrame.ncount >= v.config.c_buffsPerRowCol then

	  --c_vertDirection
	  --c_horizDirection
        if v.config.c_stackBuffsMode == _STACK_BUFFS_VERTICAL then
          v.buffFrame.xpos = v.buffFrame.xpos + (v.config.c_horizDirection * (v.config.c_bar_width + v.config.c_bar_height + v.config.c_padding))
          v.buffFrame.ypos = 0
		  
		  
        end

        if v.config.c_stackBuffsMode == _STACK_BUFFS_HORIZONTAL then

          v.buffFrame.xpos = 0
          v.buffFrame.ypos = v.buffFrame.ypos + (v.config.c_vertDirection * (v.config.c_bar_height + v.config.c_padding))
        end


        v.buffFrame.ncount = 0
      end

      v.buffFrame.ncount = v.buffFrame.ncount + 1
     

	 


      if time or v.new then
	 
 

v.frame:SetBackgroundColor(v.config.c_barbackgroundColor[1],v.config.c_barbackgroundColor[2],v.config.c_barbackgroundColor[3],v.config.c_backgroundAlpha/100)
        v.frame.txt:SetFontSize(v.config.c_font_size)
		v.frame.txt:SetFontColor(v.config.c_barfontColor[1],v.config.c_barfontColor[2],v.config.c_barfontColor[3])
		
		if v.config.c_useGradient then
		  v.frame.prog:SetTexture("PadaBuffs","Images/grad.jpg")
		else
		 v.frame.prog:SetTexture("PadaBuffs","Images/em.png")
		end
		
        v.frame.txt:SetWidth(v.config.c_bar_width)
        v.frame:SetHeight(v.config.c_bar_height)
        v.frame.icon:SetPoint("TOPLEFT", v.frame, "TOPLEFT", 0, 0) -- The icon is pinned to the top-left corner of the bar.
        --v.frame.icon:SetWidth(buff_frame_height)
        v.frame.icon:SetPoint("BOTTOM", v.frame, "BOTTOM") -- Vertically, it always fills the
        v.frame.icon:SetWidth(v.config.c_bar_height)
        v.frame.prog:SetHeight(v.config.c_bar_height)


        if v.config.c_show_prog then
          v.frame.prog:SetVisible(true)
          setBuffColor(v.frame.prog, v)
          --v.frame.prog:SetBackgroundColor(pb_def_prog_color[1],pb_def_prog_color[2],pb_def_prog_color[3],0.5)
        else

          v.frame.prog:SetVisible(false)
        end
        if v.config.c_show_icons then

          if v.icon then v.frame.icon:SetTexture("Rift", v.icon) end
          v.frame.prog:SetPoint("TOPLEFT", v.frame, "TOPLEFT", v.config.c_bar_height, 0) -- The icon is pinned to the top-left corner of the bar.
        else

          v.frame.icon:SetTexture("Rift", "")
          v.frame.prog:SetPoint("TOPLEFT", v.frame, "TOPLEFT", 0, 0) -- The icon is pinned to the top-left corner of the bar.
        end



        v.new = false

  
      end
--end update new

      --end 2


      v.frame:SetPoint("TOPLEFT", v.buffFrame, "TOPLEFT", v.buffFrame.xpos, v.buffFrame.ypos)


      
      v.frame:SetWidth(v.config.c_bar_width + v.config.c_bar_height)

	  --c_horizDirection c_vertDirection
      if v.config.c_stackBuffsMode == _STACK_BUFFS_VERTICAL then
        v.buffFrame.ypos = v.buffFrame.ypos + (v.config.c_vertDirection * (v.config.c_bar_height + v.config.c_padding))
      end

      if v.config.c_stackBuffsMode == _STACK_BUFFS_HORIZONTAL then
        v.buffFrame.xpos = v.buffFrame.xpos + (v.config.c_horizDirection * (v.config.c_bar_height + v.config.c_bar_width + v.config.c_padding))
      end
    end


    -- v.buffFrame:SetHeight(v.buffFrame.ypos)
  end
end





  
  
local function getFrame()


buff_frame_pw:SetMouseMasking("limited")
buff_frame_p:SetMouseMasking("limited")
  local fr = UI.CreateFrame("Texture", "Test", buff_frame_p)
 
  pb_frames_created = pb_frames_created + 1
fr:SetLayer(0)
fr:SetMouseMasking("limited")
  fr:SetVisible(false)
  fr:SetBackgroundColor(0, 0, 0)
  fr:SetWidth(buff_bar_width + buff_frame_height)

  fr:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -500, -300)


  fr.prog = UI.CreateFrame("Texture", "prog", fr)
  fr.prog:SetPoint("TOPLEFT", fr, "TOPLEFT", buff_frame_height, 0) 
 
   fr.prog:SetAlpha(0.5)
  -- fr.prgb = UI.CreateFrame("Frame", "prgb", fr)
 -- fr.prgb:SetPoint("TOPLEFT", fr, "TOPLEFT", buff_frame_height, 0) 
  fr.prog:SetLayer(891)

   
fr.prog:SetMouseMasking("limited")
  fr.prog:SetLayer(2)

  fr.icon = UI.CreateFrame("Texture", "Icon", fr)




 


  fr.txt = UI.CreateFrame("Text", "Test", fr)

fr.txt:SetMouseMasking("limited")
  fr.txt:SetFontSize(pd_font_size)



  fr.txt:SetLayer(10)




  return fr
end


--end
function releaseFrame(fr)
  fr:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -900, -900)
  RiftLibs:releaseCachedFrame(fr, true)
end


debuff_frame_pw = UI.CreateFrame("Frame", "lol", context)
debuff_frame_pw:SetVisible(buffFrameVisible)


debuff_frame_pw:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 600, 400)
debuff_frame_pw:SetLayer(9999)
debuff_frame_pw:SetWidth(buff_bar_width + buff_frame_height)
debuff_frame_pw:SetHeight(buff_frame_height)


debuff_frame_p = UI.CreateFrame("Text", "lol", debuff_frame_pw)


--debuff_frame_p:SetWidth(buff_bar_width+icon_width)



buff_frame_pw = UI.CreateFrame("Frame", "lol", context)
buff_frame_pw:SetVisible(buffFrameVisible)

buff_frame_pw:SetWidth(200)
buff_frame_pw:SetHeight(200)
--buff_frame_pw:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 600, 400)
buff_frame_pw:SetLayer(100)


buff_frame_p = UI.CreateFrame("Frame", "lol", buff_frame_pw)



buff_frame_drag = UI.CreateFrame("Text", "lol", buff_frame_p)
buff_frame_drag:SetVisible(false)
buff_frame_drag:SetPoint("TOPLEFT", buff_frame_p, "TOPLEFT", 0, 0)

buff_frame_drag:SetWidth(buff_bar_width + buff_frame_height)
buff_frame_drag:SetHeight(buff_frame_height)
buff_frame_drag:SetFontSize(18)
buff_frame_drag:SetText("Buff frame, Drag to move")
buff_frame_drag:SetBackgroundColor(1, 0, 0,0.8)
buff_frame_drag:SetLayer(5000)
RiftLibs:enableDrag(buff_frame_drag)


debuff_frame_drag = UI.CreateFrame("Text", "lol", debuff_frame_p)

debuff_frame_drag:SetVisible(false)
debuff_frame_drag:SetHeight(buff_frame_height)
debuff_frame_drag:SetLayer(5000)
debuff_frame_drag:SetPoint("TOPLEFT", debuff_frame_p, "TOPLEFT", 0, 0)
debuff_frame_drag:SetWidth(buff_bar_width + buff_frame_height)

debuff_frame_drag:SetFontSize(18)
debuff_frame_drag:SetText("Debuff frame, Drag to move")
debuff_frame_drag:SetBackgroundColor(1, 0, 0,0.8)
RiftLibs:enableDrag(debuff_frame_drag)




local function buffgain(un, buffs)


  if Inspect.Unit.Lookup(un) ~= "player" then
    return
  else
    playerId = un
  end

   local dets = Inspect.Buff.Detail(Inspect.Unit.Lookup(un), buffs)
   
   for k, v in pairs(dets) do
  
    pdmg_addBuff(v, k, false, true)
   end
   

  

  refresh = false


 
end



local function bufflost(un, buffs)

  if Inspect.Unit.Lookup(un) ~= "player" then
    return
  end


  for k, v in pairs(buffs) do

    pdmg_addBuff(dd, k, true, false)
  end


  refresh = false

end

vii = 0
function pdmg_addBuff(buff_details, buffi, removeBuff, refresh)


if buff_details and enableBlacklist and pbIsListed(buff_details.name,buff_blacklist) then

return
end

local isWhiteListed=false

if buff_details and enableWhitelist and pbIsListed(buff_details.name,buff_whitelist) then

isWhiteListed=true
end

  -- selfBuffsOnly
  local pl = Inspect.Unit.Lookup("player")
  if selfBuffsOnly == true and (not isWhiteListed and buff_details and buff_details.caster ~= pl and not removeBuff) then

    if not buff_details.debuff then
	
      return
    end
  end
  local bdisp = {}
  bdisp.new = true

  vii = vii + 1
  if buff_details and buff_details.debuff and showDebuffsSeperate then
    
	--	c_bar_height = buff_frame_height, currentConfig  debuff_frame_p buff_frame_p
    bdisp.buffFrame = debuff_frame_p
	bdisp.config=debuffConfig

  else
  bdisp.config=buffConfig
    bdisp.buffFrame = buff_frame_p
  end

  if removeBuff == true then
    local kh = "Unknown"
    if buff_details then
      kh = buff_details.name
    end
  end

  local t = Inspect.Time.Real()


  for k, v in pairs(buff_table) do

    if (v.key == buffi) then

      if (removeBuff == true and buff_details == nil) then
        releaseFrame(v.frame)
        table.remove(buff_table, k)
        return
      end

      local st = t
      if buff_details.remaining and buff_details.duration then

        st = st - (buff_details.remaining)
      else
      end

      return
    end
  end

  if buff_details == nil then return end

  local st = t
  if buff_details.remaining and buff_details.duration and buff_details.remaining > 0 then

    st = st - (buff_details.duration - buff_details.remaining)
  end


  bdisp.start = t

  bdisp.name = buff_details.name
  bdisp.stack = buff_details.stack
  bdisp.key = buffi

  if buff_details.poison then bdisp.poison = 1 end
  if buff_details.curse then bdisp.curse = 1 end
  if buff_details.disease then bdisp.disease = 1 end
  if buff_details.debuff then bdisp.debuff = 1 end

    if buff_details.duration==nil and not buff_details.debuff and not isWhiteListed and hideBuffNoDuration then

   return end
   
  bdisp.remaining = buff_details.remaining or INFINITE_DURATION_BUFF_DUR
  bdisp.duration = buff_details.duration or INFINITE_DURATION_BUFF_DUR

  if bdisp.duration then
    bdisp.complete = (t - (bdisp.duration - bdisp.remaining)) + bdisp.remaining
  else
 
   
    bdisp.complete = -1
  end


  --local bf = getFrame()
  local bf = RiftLibs:getCachedFrame("PadaBuffs", "bufflist", getFrame)


  --setBuffColor(bf.prog,buff_details)

  bf.txt:SetText(buff_details.name)
  
  function bf.Event:MouseIn()
	if bdisp.config.c_cancelRequireKey then 
  bf:SetKeyFocus(true)
  end
  end
  
    function bf.Event:MouseOut()

	
  bf:SetKeyFocus(false)
 
  end
  function bf.Event:KeyDown(k)
bf.kDown=true
  end
   function bf.Event:KeyUp(k)
    bf:SetKeyFocus(false)
bf.kDown=false
  end
  --c_cancelMode==_CANCEL_ON_MIDDLE

  if not buff_details.noncancelable then
  
 
   function bf.Event:MiddleClick()

    if bdisp.config.c_cancelMode==_CANCEL_ON_MIDDLE then
      if (bdisp.config.c_cancelRequireKey and bf.kDown) or not bdisp.config.c_cancelRequireKey then Command.Buff.Cancel(buffi) end
   end
   end
	   function bf.Event:RightClick()

    if bdisp.config.c_cancelMode~=_CANCEL_ON_MIDDLE then
      if (bdisp.config.c_cancelRequireKey and bf.kDown) or not bdisp.config.c_cancelRequireKey then Command.Buff.Cancel(buffi) end
   end
   end

  

   
  end

  --
  bf.txt:SetWidth(300)

  bdisp.frame = bf
  bdisp.icon = buff_details.icon

  table.insert(buff_table, bdisp)
end

local lastError = nil
function pbCallTick()
  if updateError then return end
  --pcall
  local presult, errorv = pcall(TickE)
  if presult then

  else

    if errorv ~= lastError then
      print("An error occured :(")
      print(errorv)
    end
    lastError = errorv
  end
end
local lgcheck=0
function updu()

  local t = Inspect.Time.Real()
  
  if t - lgcheck>0.250 then
   sortBuffs()
  TickE(true)
  lgcheck=t
  end
  
end
table.insert(Event.System.Update.Begin, { updu, "PadaBuffs", "refresh" })

table.insert(Event.System.Update.Begin, { pbUpdateValues, "PadaBuffs", "refresh" })

table.insert(Event.Buff.Add, { buffgain, "PadaBuffs", "buff gain" })
table.insert(Event.Buff.Change, { buffgain, "PadaBuffs", "buff change" })
table.insert(Event.Buff.Remove, { bufflost, "PadaBuffs", "buff ss" })




table.insert(Event.Addon.SavedVariables.Save.Begin, {
  function(v)

  
  PadaBuffs_Config.c_barbackgroundColor=barbackgroundColor
  PadaBuffs_Config.c_backgroundAlpha=backgroundAlpha
  PadaBuffs_Config.c_updateSpeed=updateSpeed
PadaBuffs_Config.c_selfBuffsOnly=selfBuffsOnly
  PadaBuffs_Config.c_enableBlacklist=enableBlacklist
  
  PadaBuffs_Config.c_enableWhitelist=enableWhitelist
  PadaBuffs_Config.c_hideBuffNoDuration=hideBuffNoDuration
    local left, top = buff_frame_p:GetBounds()
    local dleft, dtop = debuff_frame_p:GetBounds()

    buffConfig.x=left
    buffConfig.y=top
    debuffConfig.x=dleft
    debuffConfig.y=dtop

	local nbl = {}
	local nwl = {}

for k,v in pairs(buff_blacklist) do

table.insert(nbl,v.n)
end

for k,v in pairs(buff_whitelist) do
table.insert(nwl,v.n)

end

	PadaBuffs_Config.c_buff_blacklist=nbl
    PadaBuffs_Config.c_buff_whitelist=nwl
	
PadaBuffs_Config.c_showDebuffsSeperate=showDebuffsSeperate
  PadaBuffs_Config.c_selfBuffsOnly=selfBuffsOnly
  
	
	
      PadaBuffs_Config.c_buffConfig=buffConfig
       PadaBuffs_Config.c_debuffConfig=debuffConfig

--[[    PadaBuffs_Config.dx = dleft
    PadaBuffs_Config.dy = dtop
    PadaBuffs_Config.x = left
    PadaBuffs_Config.c_selfBuffsOnly = selfBuffsOnly
    PadaBuffs_Config.y = top
    PadaBuffs_Config.poison_c = pd_poison_color
    PadaBuffs_Config.disease_c = pd_pdisease_color
    PadaBuffs_Config.curse_c = currentConfig.curse_c
    PadaBuffs_Config.debuff_c = pd_debuff_color
    PadaBuffs_Config.buff_c = pd_buff_color
    PadaBuffs_Config.c_show_icons = show_icons
    PadaBuffs_Config.c_show_name = show_name
    PadaBuffs_Config.c_show_prog = show_prog
    PadaBuffs_Config.c_bar_width = buff_bar_width
    PadaBuffs_Config.c_bar_height = buff_frame_height
    PadaBuffs_Config.c_font_size = pd_font_size
    PadaBuffs_Config.c_buffFrameVisible = buffFrameVisible
    PadaBuffs_Config.c_buffFrameLock = buffFrameLock


    PadaBuffs_Config.c_buffsPerRowCol = buffsPerRowCol
    PadaBuffs_Config.c_stackBuffsDirection = stackBuffsDirection
    PadaBuffs_Config.c_stackBuffsMode = stackBuffsMode
    PadaBuffs_Config.c_showDebuffsSeperate = showDebuffsSeperate]]
  end, "PadaBuffs", "AAA"
})

function pbUpdateConfig(cfg)

    local vchecked = false
    local hchecked = false
    local leftup = false
    local downright = false
    if cfg.c_stackBuffsMode == _STACK_BUFFS_VERTICAL then vchecked = true else hchecked = true end
    if cfg.c_stackBuffsDirection == _DOWN_RIGHT_DIRECTION then downright = true else leftup = true end



	dmg_config_win.selfbuffs_check:SetChecked(selfBuffsOnly)
 
extra_options_win.use_gradient_text_check:SetChecked(currentConfig.c_useGradient==true)



extra_options_win.no_duration_buffs_empty_check:SetChecked(cfg.c_nodurBuffProg==_EMPTY_BAR)
extra_options_win.no_duration_buffs_check:SetChecked(cfg.c_nodurBuffProg==_FULL_BAR)

 
extra_options_win.cancel_method_middle_check:SetChecked(cfg.c_cancelMode==_CANCEL_ON_MIDDLE)
  extra_options_win.cancel_method_right_check:SetChecked(cfg.c_cancelMode~=_CANCEL_ON_MIDDLE)
extra_options_win.cancel_method_require_check:SetChecked(cfg.c_cancelRequireKey)

	extra_options_win.progress_type_dur_check:SetChecked(cfg.c_barProgressMode==_BAR_PROG_MODE_VARIABLE)
	extra_options_win.progress_type_fixed_check:SetChecked(cfg.c_barProgressMode==_BAR_PROG_MODE_FIXED)
	extra_options_win.progress_type_fixed_textfield:SetText(tostring(cfg.c_barProgressModeTime))
	
	
	extra_options_win.progress_type_fixed_slider:SetPosition(cfg.c_barProgressModeTime)
	
	
	--c_barProgressMode c_barProgressModeTime
--progress_type_dur_check progress_type_fixed_check progress_type_fixed_textfield
	
	
	-- dmg_config_win.font_color_textfield_r dmg_config_win.font_color_eg
	dmg_config_win.font_color_textfield_r:SetText(tostring(math.floor(cfg.c_barfontColor[1]*255)))
	dmg_config_win.font_color_textfield_g:SetText(tostring(math.floor(cfg.c_barfontColor[2]*255)))
	dmg_config_win.font_color_textfield_b:SetText(tostring(math.floor(cfg.c_barfontColor[3]*255)))
	
	dmg_config_win.font_color_eg:SetBackgroundColor(cfg.c_barfontColor[1],cfg.c_barfontColor[2],cfg.c_barfontColor[3])

	dmg_config_win.bar_color_textfield_r:SetText(tostring(math.floor(cfg.c_barbackgroundColor[1]*255)))
	dmg_config_win.bar_color_textfield_g:SetText(tostring(math.floor(cfg.c_barbackgroundColor[2]*255)))
	dmg_config_win.bar_color_textfield_b:SetText(tostring(math.floor(cfg.c_barbackgroundColor[3]*255)))
	
	dmg_config_win.bar_color_eg:SetBackgroundColor(cfg.c_barbackgroundColor[1],cfg.c_barbackgroundColor[2],cfg.c_barbackgroundColor[3])
	
	
	
		dmg_config_win.progress_alpha_slider:SetPosition(cfg.c_progressAlpha)
dmg_config_win.progress_alpha_textfield:SetText(tostring(cfg.c_progressAlpha))
	
	dmg_config_win.background_alpha_slider:SetPosition(cfg.c_backgroundAlpha)
dmg_config_win.background_alpha_textfield:SetText(tostring(cfg.c_backgroundAlpha))
	
dmg_config_win.update_speed_slider:SetPosition(updateSpeed)
dmg_config_win.update_speed_textfield:SetText(tostring(updateSpeed))

    dmg_config_win.left_up_check:SetChecked(cfg.c_vertDirection==-1)
    dmg_config_win.right_down_check:SetChecked(cfg.c_vertDirection==1)
	
	  dmg_config_win.left_dir_check:SetChecked(cfg.c_horizDirection==-1)
    dmg_config_win.right_dir_check:SetChecked(cfg.c_horizDirection==1)
	
    dmg_config_win.vertical_check:SetChecked(vchecked)
    dmg_config_win.hoziontal_check:SetChecked(hchecked)
    dmg_config_win.show_dps_seperate_check:SetChecked(showDebuffsSeperate)
    dmg_config_win.max_per_rowcol_field:SetText(tostring(cfg.c_buffsPerRowCol))

if cfg.c_padding<=MIN_PADDING or cfg.c_padding>=MAX_PADDING then cfg.c_padding=0 end

dmg_config_win.padding_slider:SetPosition(cfg.c_padding)
dmg_config_win.padding_amount_text:SetText(tostring(cfg.c_padding))
 



    dmg_config_win.lock_bars_check:SetChecked(cfg.c_buffFrameLock)



    dmg_config_win.visible_check:SetChecked(cfg.c_buffFrameVisible)
    buff_frame_pw:SetVisible(true)

	--currentConfig.c_buffFrameVisible


    dmg_config_win.selfbuffs_check:SetChecked(selfBuffsOnly)


    dmg_config_win.bar_display_checkbox_icon:SetChecked(cfg.c_show_icons)
    dmg_config_win.bar_display_checkbox_name:SetChecked(cfg.c_show_name)
    dmg_config_win.bar_display_checkbox_progress:SetChecked(cfg.c_show_prog)

    dmg_config_win.prog_color_eg:SetBackgroundColor(cfg.buff_c[1], cfg.buff_c[2], cfg.buff_c[3], 0.5)
    dmg_config_win.debuff_color_eg:SetBackgroundColor(cfg.debuff_c[1], cfg.debuff_c[2], cfg.debuff_c[3], 0.5)
    dmg_config_win.poison_color_eg:SetBackgroundColor(cfg.poison_c[1], cfg.poison_c[2], cfg.poison_c[3], 0.5)
    dmg_config_win.disease_color_eg:SetBackgroundColor(cfg.disease_c[1], cfg.disease_c[2], cfg.disease_c[3], 0.5)
    dmg_config_win.curse_color_eg:SetBackgroundColor(cfg.curse_c[1], cfg.curse_c[2], cfg.curse_c[3], 0.5)

    dmg_config_win.curse_color_textfield_r:SetText(tostring(math.floor(cfg.curse_c[1] * 255)))
    dmg_config_win.curse_color_textfield_g:SetText(tostring(math.floor(cfg.curse_c[2] * 255)))
    dmg_config_win.curse_color_textfield_b:SetText(tostring(math.floor(cfg.curse_c[3] * 255)))

    dmg_config_win.disease_color_textfield_r:SetText(tostring(math.floor(cfg.disease_c[1] * 255)))
    dmg_config_win.disease_color_textfield_g:SetText(tostring(math.floor(cfg.disease_c[2] * 255)))
    dmg_config_win.disease_color_textfield_b:SetText(tostring(math.floor(cfg.disease_c[3] * 255)))


    dmg_config_win.poison_color_textfield_r:SetText(tostring(math.floor(cfg.poison_c[1] * 255)))
    dmg_config_win.poison_color_textfield_g:SetText(tostring(math.floor(cfg.poison_c[2] * 255)))
    dmg_config_win.poison_color_textfield_b:SetText(tostring(math.floor(cfg.poison_c[3] * 255)))

    dmg_config_win.debuff_color_textfield_r:SetText(tostring(math.floor(cfg.debuff_c[1] * 255)))
    dmg_config_win.debuff_color_textfield_g:SetText(tostring(math.floor(cfg.debuff_c[2] * 255)))
    dmg_config_win.debuff_color_textfield_b:SetText(tostring(math.floor(cfg.debuff_c[3] * 255)))

    dmg_config_win.prog_color_textfield_r:SetText(tostring(math.floor(cfg.buff_c[1] * 255)))
    dmg_config_win.prog_color_textfield_g:SetText(tostring(math.floor(cfg.buff_c[2] * 255)))
    dmg_config_win.prog_color_textfield_b:SetText(tostring(math.floor(cfg.buff_c[3] * 255)))

  
    buff_frame_p:SetVisible(buffConfig.c_buffFrameVisible)

    
    debuff_frame_p:SetVisible(debuffConfig.c_buffFrameVisible)
	
	  dmg_config_win.text_size_slider:SetPosition(cfg.c_font_size)

    dmg_config_win.slider:SetPosition(cfg.c_bar_width)
    dmg_config_win.bar_height_slider:SetPosition(cfg.c_bar_height)



 
    buff_frame_drag:SetWidth(cfg.c_bar_width + cfg.c_bar_height)
    buff_frame_drag:SetHeight(cfg.c_bar_height)
    debuff_frame_drag:SetWidth(cfg.c_bar_width + cfg.c_bar_height)
    debuff_frame_drag:SetHeight(cfg.c_bar_height)



end

table.insert(Event.Addon.SavedVariables.Load.End, {
  function(v)

  
  local exis_b_nodurBuffProg
  local exis_d_nodurBuffProg
  
  local exis_b_useGradient
  local exis_d_useGradient
  
  local exis_bfclr
local exis_dbfclr
local exis_psnclr
local exis_disclr
local exis_curclr

local exis_de_bfclr
local exis_de_dbfclr
local exis_de_psnclr
local exis_de_disclr
local exis_de_curclr

local exis_x
local exis_y

local exis_de_x
local exis_de_y

--local _CANCEL_ON_MIDDLE = 0
-- local _CANCEL_ON_RIGHT = 1
local exis_b_cancelMode
local exis_d_cancelMode
local exis_b_cancelKeyRequire
local exis_d_cancelKeyRequire


		 
local exis_b_c_show_icons
local exis_b_c_show_name
local exis_b_c_show_prog
local exis_b_c_bar_width
local exis_b_c_bar_height
local exis_b_c_font_size

local exis_b_c_show_icons
local exis_b_c_show_name
local exis_b_c_show_prog
local exis_b_c_bar_width
local exis_b_c_bar_height
local exis_b_c_font_size

    

		local exis_b_c_buffFrameVisible
		local exis_b_c_buffFrameLock
		local exis_b_c_selfBuffsOnl
		local exis_b_c_buffsPerRowCol
		local exis_b_c_stackBuffsDirection
		local exis_b_c_stackBuffsMode
		
		local exis_d_c_buffFrameVisible
		local exis_d_c_buffFrameLock
		local exis_d_c_selfBuffsOnly
		local exis_d_c_buffsPerRowCol
		local exis_d_c_stackBuffsDirection
		local exis_d_c_stackBuffsMode
  
  
  local exis_b_prog_alpha
  local exis_b_background_alpha
    local exis_d_prog_alpha
  local exis_d_background_alpha
  
  local exis_b_backgroundcolor
  local exis_b_fontcolor
  local exis_update
  
  
  
   
			  local exis_b_c_vertDirection
			  local exis_b_c_horizDirection
			  local exis_b_c_padding
			  
			   local exis_d_c_vertDirection
			  local exis_d_c_horizDirection
			  local exis_d_c_padding
  
  local exis_white
local exis_black
  local exis_b_barProgressMode
  local exis_d_barProgressMode
  
    local exis_b_barProgressModeTime
  local exis_d_barProgressModeTime
  
  if PadaBuffs_Config then
 exis_white = PadaBuffs_Config.c_buff_whitelist 
 exis_black = PadaBuffs_Config.c_buff_blacklist


end






if PadaBuffs_Config and PadaBuffs_Config.c_buffConfig and PadaBuffs_Config.c_debuffConfig then 


  
  exis_b_nodurBuffProg=PadaBuffs_Config.c_buffConfig.c_nodurBuffProg
exis_d_nodurBuffProg=PadaBuffs_Config.c_debuffConfig.c_nodurBuffProg

exis_b_useGradient=PadaBuffs_Config.c_buffConfig.c_useGradient
exis_d_useGradient=PadaBuffs_Config.c_debuffConfig.c_useGradient



exis_b_cancelKeyRequire=PadaBuffs_Config.c_buffConfig.c_cancelRequireKey
exis_b_cancelMode=PadaBuffs_Config.c_buffConfig.exis_b_cancelMode


	exis_b_cancelKeyRequire=PadaBuffs_Config.c_buffConfig.c_cancelRequireKey
exis_d_cancelMode=PadaBuffs_Config.c_debuffConfig.exis_b_cancelMode
	 
		 
exis_b_barProgressMode=PadaBuffs_Config.c_buffConfig.c_barProgressMode
exis_d_barProgressMode=PadaBuffs_Config.c_debuffConfig.c_barProgressMode

exis_b_barProgressModeTime=PadaBuffs_Config.c_buffConfig.c_barProgressModeTime

exis_d_barProgressModeTime=PadaBuffs_Config.c_debuffConfig.c_barProgressModeTime
  
			  
		  exis_b_c_vertDirection=PadaBuffs_Config.c_buffConfig.c_vertDirection
  exis_b_c_horizDirection=PadaBuffs_Config.c_buffConfig.c_horizDirection
  exis_b_c_padding=PadaBuffs_Config.c_buffConfig.c_padding

   exis_d_c_vertDirection=PadaBuffs_Config.c_debuffConfig.c_vertDirection
  exis_d_c_horizDirection=PadaBuffs_Config.c_debuffConfig.c_horizDirection
  exis_d_c_padding=PadaBuffs_Config.c_debuffConfig.c_padding
  
  exis_b_prog_alpha=PadaBuffs_Config.c_buffConfig.c_progressAlpha
  exis_b_background_alpha=PadaBuffs_Config.c_buffConfig.c_backgroundAlpha
  
   exis_d_prog_alpha=PadaBuffs_Config.c_debuffConfig.c_progressAlpha
  exis_d_background_alpha=PadaBuffs_Config.c_debuffConfig.c_backgroundAlpha
  

  

 exis_bfclr = PadaBuffs_Config.c_buffConfig.buff_c
 exis_dbfclr = PadaBuffs_Config.c_buffConfig.debuff_c
 exis_psnclr = PadaBuffs_Config.c_buffConfig.poison_c
 exis_disclr = PadaBuffs_Config.c_buffConfig.disease_c
 exis_curclr = PadaBuffs_Config.c_buffConfig.curse_c

 exis_de_bfclr = PadaBuffs_Config.c_debuffConfig.buff_c
 exis_de_dbfclr = PadaBuffs_Config.c_debuffConfig.debuff_c
 exis_de_psnclr = PadaBuffs_Config.c_debuffConfig.poison_c
 exis_de_disclr = PadaBuffs_Config.c_debuffConfig.disease_c
 exis_de_curclr = PadaBuffs_Config.c_debuffConfig.curse_c

 exis_x = PadaBuffs_Config.c_buffConfig.x
 exis_y = PadaBuffs_Config.c_buffConfig.y

 exis_de_x = PadaBuffs_Config.c_debuffConfig.x
 exis_de_y = PadaBuffs_Config.c_debuffConfig.y



 exis_b_c_show_icons=PadaBuffs_Config.c_buffConfig.c_show_icons
 exis_b_c_show_name=PadaBuffs_Config.c_buffConfig.c_show_name
 exis_b_c_show_prog=PadaBuffs_Config.c_buffConfig.c_show_prog
 exis_b_c_bar_width=PadaBuffs_Config.c_buffConfig.c_bar_width
 exis_b_c_bar_height=PadaBuffs_Config.c_buffConfig.c_bar_height
 exis_b_c_font_size=PadaBuffs_Config.c_buffConfig.c_font_size

 exis_d_c_show_icons=PadaBuffs_Config.c_debuffConfig.c_show_icons
 exis_d_c_show_name=PadaBuffs_Config.c_debuffConfig.c_show_name
 exis_d_c_show_prog=PadaBuffs_Config.c_debuffConfig.c_show_prog
 exis_d_c_bar_width=PadaBuffs_Config.c_debuffConfig.c_bar_width
 exis_d_c_bar_height=PadaBuffs_Config.c_debuffConfig.c_bar_height
 exis_d_c_font_size=PadaBuffs_Config.c_debuffConfig.c_font_size

  

		 exis_b_c_buffFrameVisible = PadaBuffs_Config.c_buffConfig.c_buffFrameVisible
		 exis_b_c_buffFrameLock = PadaBuffs_Config.c_buffConfig.c_buffFrameLock
		 exis_b_c_selfBuffsOnly = PadaBuffs_Config.c_buffConfig.c_selfBuffsOnly
		 exis_b_c_buffsPerRowCol = PadaBuffs_Config.c_buffConfig.c_buffsPerRowCol
		 exis_b_c_stackBuffsDirection = PadaBuffs_Config.c_buffConfig.c_stackBuffsDirection
		 exis_b_c_stackBuffsMode = PadaBuffs_Config.c_buffConfig.c_stackBuffsMode
		
		 exis_d_c_buffFrameVisible = PadaBuffs_Config.c_debuffConfig.c_buffFrameVisible
		 exis_d_c_buffFrameLock = PadaBuffs_Config.c_debuffConfig.c_buffFrameLock
		 exis_d_c_selfBuffsOnly = PadaBuffs_Config.c_debuffConfig.c_selfBuffsOnly
		 exis_d_c_buffsPerRowCol = PadaBuffs_Config.c_debuffConfig.c_buffsPerRowCol
		 exis_d_c_stackBuffsDirection = PadaBuffs_Config.c_debuffConfig.c_stackBuffsDirection
		 exis_d_c_stackBuffsMode = PadaBuffs_Config.c_debuffConfig.c_stackBuffsMode

end

--c_barbackgroundColor  dmg_config_win.bar_color_textfield_g  c_useGradient
    if PadaBuffs_Config == nil or PadaBuffs_Config.c_buffConfig.c_useGradient == nil then


      PadaBuffs_Config = {
	  c_updateSpeed=updateSpeed,
	  c_hideBuffNoDuration=false,
	  c_enableBlacklist=true,
	  c_enableWhitelist=true,
	  c_buff_blacklist=exis_black or {},
	  c_buff_whitelist=exis_white or {},
	  c_selfBuffsOnly=true,
        c_showDebuffsSeperate=true,
        c_buffConfig={
		
		


c_nodurBuffProg=exis_b_nodurBuffProg or _FULL_BAR,
c_useGradient=exis_b_useGradient or true,

		
		
		
		c_cancelRequireKey=exis_b_cancelKeyRequire or false,
		 c_cancelMode=exis_b_cancelMode or _CANCEL_ON_RIGHT,
		c_barProgressMode=exis_b_barProgressMode or barProgressMode,
		c_barProgressModeTime=exis_b_barProgressModeTime or barProgressModeTime,
		c_progressAlpha=exis_b_prog_alpha or progressAlpha,
			  c_backgroundAlpha=exis_b_background_alpha or backgroundAlpha,
	  c_barbackgroundColor={barbackgroundColor[1],barbackgroundColor[2],barbackgroundColor[3]},
	  c_barfontColor={barfontColor[1],barfontColor[2],barfontColor[3]},
        x = exis_x  or 400,
        y = exis_y  or 300,
		

		c_vertDirection=exis_b_c_vertDirection or vertDirection,
		c_horizDirection=exis_b_c_horizDirection or horizDirection,
			  c_padding=exis_b_c_padding or buff_display_padding,
			  
        poison_c = exis_psnclr or {pd_poison_color[1],pd_poison_color[2],pd_poison_color[3]},
        disease_c = exis_disclr  or {pd_pdisease_color[1],pd_pdisease_color[2],pd_pdisease_color[3]},
        curse_c = exis_curclr or {pd_curse_color[1],pd_curse_color[2],pd_curse_color[3]},
        debuff_c = exis_dbfclr  or {pd_debuff_color[1],pd_debuff_color[2],pd_debuff_color[3]},
        buff_c = exis_bfclr or {pd_buff_color[1],pd_buff_color[2],pd_buff_color[3]},
        c_show_icons = exis_b_c_show_icons or true,
        c_show_name = exis_b_c_show_name or true,
        c_show_prog = exis_b_c_show_prog or true,
        c_bar_width = exis_b_c_bar_width or buff_bar_width,
        c_bar_height = exis_b_c_bar_height or buff_frame_height,
        c_font_size = exis_b_c_font_size or pd_font_size,
		

        c_buffFrameVisible = exis_b_c_buffFrameVisible or buffFrameVisible,
        c_buffFrameLock = exis_b_c_buffFrameLock or buffFrameLock,
        c_selfBuffsOnly = exis_b_c_selfBuffsOnly or selfBuffsOnly,
        c_buffsPerRowCol = exis_b_c_buffsPerRowCol or buffsPerRowCol,
        c_stackBuffsDirection = exis_b_c_stackBuffsDirection or stackBuffsDirection,
        c_stackBuffsMode = exis_b_c_stackBuffsMode or stackBuffsMode},
        c_debuffConfig={
	
		c_nodurBuffProg=exis_d_nodurBuffProg or _FULL_BAR,
c_useGradient=exis_d_useGradient or true,
		c_cancelRequireKey=exis_b_cancelKeyRequire or false,
		 c_cancelMode=exis_b_cancelMode or _CANCEL_ON_RIGHT,
		c_barProgressMode=exis_d_barProgressMode or barProgressMode,
		c_barProgressModeTime=exis_d_barProgressModeTime or barProgressModeTime,
			c_progressAlpha=exis_d_prog_alpha or progressAlpha,
			  c_backgroundAlpha=exis_d_background_alpha or backgroundAlpha,
	  c_barbackgroundColor={barbackgroundColor[1],barbackgroundColor[2],barbackgroundColor[3]},
	  c_barfontColor={barfontColor[1],barfontColor[2],barfontColor[3]},
				c_vertDirection=exis_d_c_vertDirection or vertDirection,
		c_horizDirection=exis_d_c_horizDirection or horizDirection,
			  c_padding=exis_d_c_padding or buff_display_padding,
        x = exis_de_x  or 200,
        y = exis_de_y  or 100,
        poison_c = exis_de_psnclr or {pd_poison_color[1],pd_poison_color[2],pd_poison_color[3]},
        disease_c = exis_de_disclr  or {pd_pdisease_color[1],pd_pdisease_color[2],pd_pdisease_color[3]},
        curse_c = exis_de_curclr or {pd_curse_color[1],pd_curse_color[2],pd_curse_color[3]},
        debuff_c = exis_de_dbfclr  or {pd_debuff_color[1],pd_debuff_color[2],pd_debuff_color[3]},
        buff_c = exis_de_bfclr or {pd_buff_color[1],pd_buff_color[2],pd_buff_color[3]},
        c_show_icons = exis_d_c_show_icons or true,
        c_show_name = exis_d_c_show_name or true,
        c_show_prog = exis_d_c_show_prog or true,
        c_bar_width = exis_d_c_bar_width or buff_bar_width,
        c_bar_height = exis_d_c_bar_height or buff_frame_height,
        c_font_size = exis_d_c_font_size or pd_font_size,
         c_buffFrameVisible = exis_d_c_buffFrameVisible or buffFrameVisible,
        c_buffFrameLock = exis_d_c_buffFrameLock or buffFrameLock,
        c_selfBuffsOnly = exis_d_c_selfBuffsOnly or selfBuffsOnly,
        c_buffsPerRowCol = exis_d_c_buffsPerRowCol or buffsPerRowCol,
        c_stackBuffsDirection = exis_d_c_stackBuffsDirection or stackBuffsDirection,
        c_stackBuffsMode = exis_d_c_stackBuffsMode or stackBuffsMode}
      }
    
    end

	
	selfBuffsOnly=PadaBuffs_Config.c_selfBuffsOnly
updateSpeed=PadaBuffs_Config.c_updateSpeed
if updateSpeed>5 then updateSpeed = 2 end
updateSpeedSecPer=1/updateSpeed
	
	hideBuffNoDuration=PadaBuffs_Config.c_hideBuffNoDuration
	dmg_config_win.hide_no_dur_check:SetChecked(hideBuffNoDuration)

enableBlacklist=PadaBuffs_Config.c_enableBlacklist

pb_blacklist_ui.enable_blacklist:SetChecked(enableBlacklist)

currentList=buff_whitelist



for k,v in pairs(PadaBuffs_Config.c_buff_whitelist) do

pbAddBlacklistBuff(v,1)
end

   for k,v in pairs(currentList) do
   v.new=true
  
end


currentList=buff_blacklist

for k,v in pairs(PadaBuffs_Config.c_buff_blacklist) do

pbAddBlacklistBuff(v,1)
end


pbPositionBlacklist()
     buffConfig = PadaBuffs_Config.c_buffConfig;
showDebuffsSeperate=PadaBuffs_Config.c_showDebuffsSeperate
    debuffConfig = PadaBuffs_Config.c_debuffConfig;


      currentConfig =  buffConfig
	  

	 

	 
pbUpdateConfig(currentConfig)
 debuff_frame_p:SetPoint("TOPLEFT", UIParent, "TOPLEFT", debuffConfig.x, debuffConfig.y)
	  buff_frame_p:SetPoint("TOPLEFT", UIParent, "TOPLEFT", buffConfig.x, buffConfig.y)
	   
  end, "PadaBuffs", "refresh"
})


function reloadBuffs()



  for k2, v2 in pairs(buff_table) do

    releaseFrame(v2.frame)
  end
  buff_table = {}
  local sBuff = Inspect.Buff.List("player")
  if not sBuff then return end

  for k, v in pairs(sBuff) do

    local dd = Inspect.Buff.Detail(Inspect.Unit.Lookup("player"), k)

    -- if dd.duration then
    pdmg_addBuff(dd, k, false, true)

    --end
  end
  
  if enableDebugBuffs then
  addDebugBuffs()
  end
  
end

--  pdmg_addBuff(dd,k,false,true)



table.insert(Command.Slash.Register("pbdebug"), {
  function(commandLineParameters)
RiftLibs:getNumCachedFrame()


  local t = Inspect.Time.Frame()

 
  end, "PadaBuffs", "Slash command"
})

table.insert(Command.Slash.Register("pbconfig"), {
  function(commandLineParameters)
  configWinOpen=true
  
	if commandLineParameters=="buff" then
	dmg_config_rt:SetTitle("PadaBuffs [Buff] Configuration")
	currentConfig=buffConfig
	else
	dmg_config_rt:SetTitle("PadaBuffs [Debuff] Configuration")
	currentConfig=debuffConfig
	end
	pbUpdateConfig(currentConfig)
  

buff_frame_drag:SetVisible(true)
    debuff_frame_drag:SetVisible(true)
    dmg_config_rt:SetVisible(true)
  end, "PadaBuffs", "Slash command"
})

table.insert(Command.Slash.Register("pbunlock"), {
  function()

    buffFrameLock = true
  end, "PadaBuffs", "Slash command"
})


table.insert(Command.Slash.Register("pblock"), {
  function(commandLineParameters)

    buffFrameLock = false
  end, "PadaBuffs", "Slash command"
})

print(_ADDON_NAME, _ADDON_VERSION, "Loaded type /pbconfig to edit settings")

