RiftLibs = {}
local rlmt = {}
local riftlibs_frame_cache = {}
local rlibs_frame_count = 0


function RiftLibs:SecondsConvert(nSeconds)

if nSeconds == 0 then

return "00:00:00";
else
--nHours = string.format("%02.f", math.floor(nSeconds/3600));
nMins = string.format("%02.f", math.floor(nSeconds/60));
nSecs = string.format("%02.f", math.floor(nSeconds - nMins *60));
return nMins..":"..nSecs
end
end

function RiftLibs:comma_value(amount,sep)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1'..sep..'%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

function RiftLibs:releaseCachedFrame(sframe,dontHide)
if not dontHide then
sframe:SetVisible(false)
end

sframe._RIFTLIBS_FRAME_ACTIVE=false
end


	   function RiftLibs:round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end


function RiftLibs:splitString(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        return t
end


function RiftLibs:getNumCachedFrame()

print(rlibs_frame_count)
end

function RiftLibs:getCachedFrame(addonName,frameName,generateFrame,getFrameArgs)



for k,v in pairs(riftlibs_frame_cache) do

   if v.addon==addonName then
   
		for k2,v2 in pairs(v.frames) do
			if v2.name==frameName and v2.frame._RIFTLIBS_FRAME_ACTIVE==false then 
			v2.frame._RIFTLIBS_FRAME_ACTIVE=true
			return v2.frame end
			
		end
		
		local frameToAdd = generateFrame(getFrameArgs)
		rlibs_frame_count = rlibs_frame_count+1
		table.insert(v.frames,{_RIFTLIBS_FRAME_ACTIVE=true,name=frameName,frame=frameToAdd})
		return frameToAdd
   
   end

		
		

		
		
		
end

      
   local frameToAdd = generateFrame(getFrameArgs)
   rlibs_frame_count = rlibs_frame_count+1
   local toAdd = {addon=addonName,frames={{_RIFTLIBS_FRAME_ACTIVE=true,name=frameName,frame=frameToAdd}}}
  
		table.insert(riftlibs_frame_cache,toAdd)
		return frameToAdd
--END
end

 function RiftLibs:new(s)
   return setmetatable({ value = s or '' }, rlmt)
 end



 rlmt.__add = function (a,b) return RiftLibs:new(a.value..b.value) end
 rlmt.__mul = function (a,b) return RiftLibs:new(string.rep(a.value, b)) end
 rlmt.__index = RiftLibs

 -- 
function RiftLibs:enableDrag(frame,parent,onRelease,allow)


  frame.drxs = 0
	  frame.drys = 0
	  
	  frame.getPos = false
	  frame.drg = false
	  
	     function frame.Event:LeftDown()
	  
	
		if not allow or allow() then
	  frame.getPos = true
	  frame.drg = true
	  end
	  
	
	  end
	  
	  
	  
	         function frame.Event:LeftUpoutside()
	  
	if onRelease then
	onRelease({x=frame.drxs,y=frame.drys})
	end
	
	  frame.drg = false
	  end
	  
	       function frame.Event:LeftUp()
	  
	if onRelease then
	onRelease({x=frame.drxs,y=frame.drys})
	end
	 
	  frame.drg = false
	  end
	  
	  
	      function frame.Event:MouseMove(x,y)
	  
	 
	  if frame.getPos then
	  frame.getPos = false
	  local left,top = frame:GetBounds()
	
	  frame.drxs = x-left
	  frame.drys = y-top
	
	  
	  end
	  if frame.drg then
		if parent==nil then
	   frame:GetParent():SetPoint("TOPLEFT", UIParent, "TOPLEFT", (x-frame.drxs), (y-frame.drys))
	   else
	   parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (x-frame.drxs), (y-frame.drys))
		end
	  end
	  
	  end

end


function RiftLibs:applyBorder(frame,border_width,color)
  
  if not color then color = {0.73,0.23,0.41} end
  
  local f = UI.CreateFrame("Frame", "BorderT", frame);

f:SetLayer(-999)
  f:SetPoint("TOPLEFT", frame, "TOPLEFT",-border_width,-border_width);
  f:SetWidth(frame:GetWidth()+(border_width*2))
  f:SetHeight(frame:GetHeight()+(border_width*2))
  
  
  
  function frame.Event:Size()
  
  
  f:SetWidth(frame:GetWidth()+(border_width*2))
  f:SetHeight(frame:GetHeight()+(border_width*2))
  end
  
 
  f:SetBackgroundColor(color[1],color[2],color[3]);
  return f
 
  end

